;........1.........2.........3.........4.........5.........6.........7.........8

pro mapcar



;===============================================================================
; This routine plots maps of different data and model outputs of IBM,
; CARAIB and associated models. Many options are included. 
; You can chose:	- the geographical zone studied with iwin;
;			- the data plotted with kplot;
;			- the list of pft's or BAG's you use with jbag
;===============================================================================

;===============================================================================
;
; Before runing this program, the user has to choose the parameters below
;
;===============================================================================
; iperiod : number for different CARAIB simulations (e.g., different periods)



nrun = 1

jrun=[1,0]

nyear=nrun
myear=intarr(nyear)
for iyr=0,nyear-1 do myear(iyr)=1990

 

for irun = 1,nrun do begin

iperiod=jrun(irun-1)

;default value for ksite
ksite = 0
;default value for ibw
ibw = 0
;default value for icont
icont = 0
;default value for jbagtol
jbagtol = 0
;default value for isol
isol = 0
;default value for jloc
jloc = 0
;default value for jdis
jdis = 0
;default value for ifrac
ifrac = 1
;default value for nlu (number of land use types)
nlu = 6
;default value for facmul
facmul = 1

;default value for ianom
;===============================================================================
; Anomaly maps
; ianom = choice between maps of absolute values or anomalies
;            ianom=0 : plot absolute values
;            ianom=1 : plot anomaly maps (reference fields must be defined 
;                      for each simulation, i.e. for each value of 'iperiod')
;            ianom=2 : plot factor of increase (reference fields must be defined 
;                      for each simulation, i.e. for each value of 'iperiod')
;
;===============================================================================
ianom = 0


;===============================================================================
; number of plant functional types (grass, tree, total)
;     jbag = 0 : 17 bag from Laurent et al.
;     jbag = 1   15 PFTs (global)
;     jbag = 2   17 bag + species
;     jbag = 3   26 BAGs
;     jbag = 4   tests with selected BAGs or species
;     jbag = 5   26 BAGs + species
;     jbag = 6   Afr (deciduous species)
;     jbag = 7   Afr (33 species)
;     jbag = 8   26 PFTs (global)
;     jbag = 9   SAmFl 75 species
;     jbag = 10  Afr_all (91 tree species + 9 grass/shrub)
;     jbag = 11  BEL (29 species)
;     jbag = 12  Afr12 (Central Africa - 12 species)
;     jbag = 13  GLOBAL (26 NAT PFTs + 16 CROP PFTs + 2 PASTURE PFTs)
;     jbag = 14  Brazil mountain species (2 herbpfts + 5 tree species)
;     jbag = 15  40 European trees (CORDEX)
;     jbag = 16  40 Cedrus altantica + Q ilex (CQ)
;     jbag = 17  ara species
;     jbag = 18  Morocco species
;===============================================================================
; default value for jbag
jbag = 8

; default value for land use paths and extensions
pathlu=''
pathfcr=''
ext_lu=''
ext_fcr=''

;===============================================================================
; run depending data
;===============================================================================
; iperiod= simulation run identifier
; npix = number of pixels in file 
; dlg = resolution in longitude (deg)
; dlt = resoltion in latitude (deg)



if iperiod eq 0 then  begin
     jbag = 8
     npix=10260
     dc13_atm = -8
     pathcres='../results/Luxemburg/HadGEM2-A0/'     
     pathclim='../clim/Luxemburg/HadGEM2-A0/'
     pathtext='../clim/Luxemburg/'
     ext_clim='_rcp85_MEAN2071_2100.dat'
     ext_txt='.dat'     
     ext_res='_rcp85_MEAN2071_2100.res'

     label = 'Mean 2071-2100'
     dlg = 0.0083333
     dlt = 0.0083333
   ; output directory
     dirps='../ps/Luxemburg/HadGEM2-A0/'
       
     icont=1
     strtime = '_rcp85_MEAN2071_2100_'   
    
  ; path for reference run when anomalies are used (ianom=1 or 2)
     pathrefcres='../results/Luxemburg/HadGEM2-A0/'     
     pathrefclim='../clim/Luxemburg/HadGEM2-A0/'
     pathreftext='../clim/Luxemburg/'
     ext_refclim='_rcp85_MEAN2071_2100.dat'
     ext_reftxt='.dat'     
     ext_refres='_rcp85_MEAN2071_2100.res' 
     
  ; file with polygon vertices when polygon are used (ipoly=1,2)     
     file_polygon='/home/francois/idl/polygon.dat'
     
  ; flag for format of Csoil file
  ;  isoilfile = 0 csoil values per pft (old format)
  ;  isoilfile = 1 only total csoil value for all pfts together (new format)
     isoilfile = 1
     
  ; overplot site presence/absence data points 
  ; ksite = controls the plots of site data points (0 = no plot; 1 = plot)
  ; nsite = number of sites
  ; filesite = input file with site data (only trees are taken into account)
  ;            long  lat  frc(trees) 
  ; fsite_thres = threshold in species abundance for assuming presence
     ksite = 0
     nsite = 1153
     filesite = '/raid3/umccb/clim0017/Ara1/data/ara1_species.txt'
     fsite_thres = 0.1
  ; plot localities on maps
  ;  jloc     : controls locality plot
  ;    jloc = 0 : no plot of localities
  ;    jloc = 1 : plot localities referred with their number
  ;    jloc = 2 : plot localities referred with their names (provided they are given in the file)
  ;    jloc = 3 : plot localities as a dot, but without their numbers or names
  ;  fileloc  : name of the file containing localities
  ;  nloc     : number of localities in files, including those which are not plotted (Prt=0)          
     jloc = 0
     fileloc='./cedrus_sites.dat'
     nloc = 20  
  ; plot distribution data
     jdis = 0
     filedis='/raid3/umccb/francois/vulpes_species_brazil/spec_occurrence_lat_long/podocarpus_lambertii_species.txt'
     ndis = 195                        
endif

if iperiod eq 1 then  begin
     jbag = 8
     npix=1859
     dc13_atm = -7.7
     pathcres='../results/Belgium/MAR/CRU/'     
     pathclim='../clim/Belgium/MAR/CRU/'
     pathtext='../clim/Belgium/MAR/'
     ext_clim='MEAN1971_2000.dat'
     ext_txt='.dat'     
     ext_res='MEAN1971_2000.res'

     label = 'MEAN1971_2000'
     dlg = 0.1000000
     dlt = 0.0666666
   ; output directory
     dirps='../ps/Belgium/MAR/CRU/'
       
     icont=1
     strtime = '_MEAN1971_2000_'   
    
  ; path for reference run when anomalies are used (ianom=1 or 2)
     pathrefcres='../results/Belgium/MAR/CRU/'     
     pathrefclim='../clim/Belgium/MAR/CRU/'
     pathreftext='../clim/Belgium/MAR/'
     ext_refclim='MEAN1971_2000.dat'
     ext_reftxt='.dat'     
     ext_refres='MEAN1971_2000.res' 
     
  ; file with polygon vertices when polygon are used (ipoly=1,2)     
     file_polygon='/home/francois/idl/polygon.dat'
     
  ; flag for format of Csoil file
  ;  isoilfile = 0 csoil values per pft (old format)
  ;  isoilfile = 1 only total csoil value for all pfts together (new format)
     isoilfile = 1
     
  ; overplot site presence/absence data points 
  ; ksite = controls the plots of site data points (0 = no plot; 1 = plot)
  ; nsite = number of sites
  ; filesite = input file with site data (only trees are taken into account)
  ;            long  lat  frc(trees) 
  ; fsite_thres = threshold in species abundance for assuming presence
     ksite = 0
     nsite = 1153
     filesite = '/raid3/umccb/clim0017/Ara1/data/ara1_species.txt'
     fsite_thres = 0.1
  ; plot localities on maps
  ;  jloc     : controls locality plot
  ;    jloc = 0 : no plot of localities
  ;    jloc = 1 : plot localities referred with their number
  ;    jloc = 2 : plot localities referred with their names (provided they are given in the file)
  ;    jloc = 3 : plot localities as a dot, but without their numbers or names
  ;  fileloc  : name of the file containing localities
  ;  nloc     : number of localities in files, including those which are not plotted (Prt=0)          
     jloc = 0
     fileloc='./cedrus_sites.dat'
     nloc = 20  
  ; plot distribution data
     jdis = 0
     filedis='/raid3/umccb/francois/vulpes_species_brazil/spec_occurrence_lat_long/podocarpus_lambertii_species.txt'
     ndis = 195                        
endif



; make output ps directory
file_mkdir,dirps

; plot continental border
;     yes: icont=1   no: icont=0
;     filecont= file where continental grid is read
;     ncont = number of pixels in file
;     resc_lg, resc_lt = resolution of the grid along longitude, latitude
;     format for read: igg_read=0 -->  long, lat
;                      igg_read=1 -->  igg, long, lat
    
   filecont=pathtext+'ecotxt'+ext_txt 
   igg_read = 1   
   ncont = long(npix)
   resc_lg = dlg
   resc_lt = dlt
   
; reads locality files
   if jloc ne 0 then begin
     close,99
     openr,99,fileloc
     sdata=''
     locrg=''
     locna='' 
     sdata1=''    
     loclong=fltarr(nloc)
     loclat=fltarr(nloc)          
     locnum=intarr(nloc)
     locprt=intarr(nloc)
     locjnm=intarr(nloc)
     locplp=intarr(nloc)          
     locreg=strarr(nloc)     
     locname=strarr(nloc)
     readf,99,sdata
     for jl = 0, nloc-1 do begin
      readf,99,sdata,sdata1,format='(a50,a150)'
      reads,sdata,loclg,loclt,locn,locpr,locjn,locpl
      if locjn ne 0 then reads,sdata1,locrg,locna,format='(a9,1x,a140)'
      loclong(jl)=loclg
      loclat(jl)=loclt
      locnum(jl)=locn
      locprt(jl)=locpr
      locjnm(jl)=locjn
      locplp(jl)=locpl
      locreg(jl)=locrg
      locname(jl)=locna
;      print,loclong(jl),loclat(jl),locnum(jl),locprt(jl),locjnm(jl)
;      print,strtrim(locreg(jl),2),' ',strtrim(locname(jl),2)
     endfor
     close,99
   endif
   
 ; read distribution data
   if jdis ne 0 then begin
     close,98
     openr,98,filedis 
     dislong=fltarr(ndis)
     dislat=fltarr(ndis)
     diselv=fltarr(ndis)
     sdata=''
     readf,98,sdata,format='(a1)'
     for jd = 0, ndis-1 do begin
      readf,98,aaa,bbb,ccc
      print,jd,aaa,bbb,ccc
      dislong(jd)=aaa
      dislat(jd)=bbb
      diselv(jd)=ccc
;      print,dislong(jd),dislat(jd),jd,ndis
     endfor
     close,98
     print,'Elevation range: ', min(diselv),' - ',max(diselv),' meters'                 
   endif
   
;===============================================================================
; Geographic projection
; igpro = controls use of geographic projection
;            igpro=0 : no geographic projection (equidistant plot in long & lat)
;            igpro=1 : use map_set for geographic projection
;                      (type of projection must be specified in map_set line)
; projection_name = a string character with the name of geographic projection 
;                   to be used
;                   => available projection types can be found with the commands:
;                          map_proj_info,proj_names=names
;                          print,names
; i_projcenter = controls the use of non default projection plane center
;            i_projcenter = 0 : uses default center of projection plane 
;                                (i.e.,p0_lat=0, p0_long=0)
;            i_projcenter = 1 : sets center of projection plane to coordinates
;                               defined in p0_lat and p0_long
;===============================================================================
igpro = 1
;projection_name = 'AlbersEqualAreaConic'
projection_name = 'Cylindrical'
;i_projcenter=0
;projection_name = 'HammerAitoff'
i_projcenter=1
p0_lat=0.
p0_long=20.

;===============================================================================
; Polygons
; ipoly = allows to use polygons for the pixels instead of regular pixels
;         ipoly = 0   use regular pixels
;         ipoly = 1   use polygons
;         ipoly = 2   use polygons with a black line contour
; If ipoly=1 or ipoly=2,a file must be supplied by the user with the latitudes  
; and longitudes of the corners (vertices) of the polygons for each pixel
;     file format:
;         longc,latc,nver,longv,latv
;     where longc, latc = longitude & latitude of the center of the polygons
;                         (same values as for other CARAIB output files)
;           nver = number of vertices (may vary from one pixel to the other)
;           longv = vector of nver components with longitudes of the vertices
;           latv  = vector of nver components with latitudes of the vertices
;     One line per pixel. Pixels (lines) must ordered in the same way as in 
;     other CARAIB output files. 
;     The path and name of the file is defined in "iperiod" section.
;===============================================================================
ipoly = 0




;===============================================================================
; window (geographical region) to plot (deg)
;  iwin=0 (global); iwin=1 (EUR); iwin=2 (WEur); iwin=3 (Europe+North Africa);
;  iwin=4 EURS; iwin=5 (Madagascar); iwin=6 (SE_EUR); iwin=7 (Itatiaia); iwin=8 (Sahara);
;  iwin=9 (WEur);  iwin = 10 (CHN) ; iwin = 11 (Belgium) ; iwin =12 (Africa)
;  iwin=13 (NZE);iwin=14 (SAmFl) ; iwin=15 (EURASIA)
;  iwin=16 (EUR10) iwin=17 (RDC) iwin=18 (TEN) iwin=19 (Atlas) iwin=20 (Bolivia)
;  iwin=21 (NW Morocco),iwin=22 (Benelux/W Germany), iwin=23 (Luxemburg)
;  iwin=24 (Central Europe - MAPPY), iwin=25 (Wallonia)
;===============================================================================

iwin=11

; ======================================================================
; plot grid : igrid (0=no/1=yes)
;========================================================================
  igrid=1

;========================================================================
; plot elevation contours : i_elevcont (0=no/1=yes)
;========================================================================
i_elevcont = 0
;========================================================================


;===============================================================================
; kplot : controls type of plot
; kplot = -64 Annual Herbaceous/Woody Litter, Soil carbon  (g C m-2)
; kplot = -63 Annual Biomass of Forests, Crops, Pastures   (g C m-2)
; kplot = -62 Crop relative fractions within (potential) crop LU 
; kplot = -61 Land use fractions
; kplot = -60 User-defined plot
; kplot = -59 soil texture (sand, silt, clay)
; kplot = -58 Minimum Daily Soil Water, IBM vegetation cover, root depth
; kplot = -57 Number of species with NPP hihgher than a prescribed threshold 
; kplot = -56 Wood production or crop yield (t/ha/yr)
; kplot = -55 Carbonate weathering rate (mol Ca m-2 mo-1 or mol Ca m-2 yr-1)
; kplot = -54 Soil PCO2 below the root zone (ppmv)
; kplot = -53 Monthly/annual lapse rate (C/km)
; kplot = -52 Monthly/annual specific humidity (g/kg)
; kplot = -41 Monthly/annual total biomass (g C m-2)
; kplot = -40 Monthly/annual net radiation flux Rn (W m-2)
; kplot = -39 Monthly/annual global solar radiation flux (W m-2)
; kplot = -38 Monthly/annual snow depth (mm)
; kplot = -37 Monthly/annual latent heat flux (W m-2) 
; kplot = -36 Monthly/annual sensible heat flux (W m-2)
; kplot = -35 Monthly/annual surface temperature (C) 
; kplot = -34 Monthly soil water (SW-WP)/(FC-WP)
; kplot = -33 Monthly/annual runoff (mm/mo mm/yr)
; kplot = -32 Monthly/annual AET (mm/mo mm/yr)
; kplot = -31 Monthly/annual PET (mm/mo mm/yr)
; kplot = -30 Monthly/annual albedo (0-1)
; kplot = -29 Monthly/annual mean wind speed (m/s)
; kplot = -28 Monthly/annual mean air relative humidity (%)
; kplot = -27 Monthly/annual mean sunshine hours (%)
; kplot = -26 Monthly/annual precipitation (mm/mo mm/yr)
; kplot = -25 Monthly/annual mean diurnal temperature range (C)
; kplot = -24 Monthly/annual mean air temperature (C) 
; kplot = -23 Temperature extremes (Tdmin,Tdmax,Tdnmin,Tddmax,Tmmin,Tmmax)
; kplot = -22 GDD0 or GDD5
; kplot = -21 Elevation
; kplot = -20 Monthly NBP (gC/m2/mo)
; kplot = -19 Monthly Ra (gC/m2/mo)
; kplot = -18 Monthly NEP (gC/m2/mo)
; kplot = -17 Monthly GPP (gC/m2/mo)
; kplot = -16 Monthly NPP (gC/m2/mo)
; kplot = -15 Monthly LAI (m2/m2)
; kplot = -14 Percentage of pixel area burned (%)
; kplot = -13 Area burned per pixel (ha)
; kplot = -12 Probability of fire (per 1000 km2 and per month)
; kplot = -11 Fire return interval (yr)
; kplot = -10 NPP of grasses and shrubs
; kplot = -9 Vegetation Carbon (kg C m-2)
; kplot = -8 Litter & Soil Carbon (kg C m-2)
; kplot = -7 Total Carbon (kg C m-2)
; kplot = -6 Average d13C
; kplot = -5 Biome map
; kplot = -4 LAI of trees (max)
; kplot = -3 LAI of the pixel (max)
; kplot = -2 R=NPP(tree)/(NPP(grass)+NPP(tree)) 
; kplot = -1 Dominant PFT
; kplot = 0  Mean pixel NPP
; kplot = 1  NPP of PFTs (nplant ps files created)
; kplot = 2  Cover fractions of PFTs in vegetation storeys (nplant ps files created)
; kplot = 3  Contribution to local NPP of PFTs (nplant ps files created)
; kplot = 4  frac*NPP of PFTs (nplant ps files created)
; kplot = 5  13C fractionations of PFTs (nplant ps files created)
; kplot = 6  Distribution of PFTs (nplant ps files created)
; kplot = 7  Biomasses of PFTs (nplant ps files created)
; kplot = 8  frac*Biomasses of PFTs (nplant ps files created)
; kplot = 9  Altitudinal ranges of PFTs (nplant ps files created)
; kplot = 10 Crops yields
;===============================================================================

kplot=-26

if (kplot eq -5) or (kplot eq -1) then ianom = 0

;===============================================================================
; When kplot is equal to -12, -13, -14, -15, -16, -17, -18,-19,-20, -24, -25, -26, -27
; -28, -29, -30, -31, -32, -33 -34 -35 -36 -37 -38 -39 -40 -41 -52 -53 -54 -55 you may plot 
; monthly, extremum or annual data using the imonth parameter:
;
;   imonth = -17 Sum of monthly values for user-defined set of months
;   imonth = -13 to -16 Seasonal sum of monthly values (-13=DJF,-14=MAM,-15=JJA,-16=SON)
;   imonth = -3 Minimum monthly value
;   imonth = -2 Maximum monthly value
;   imonth = -1 Yearly sum of all monthly values
;   imonth =  0 Annual mean value
;   imonth =  1-12 Monthly value
;   imonth =  13-16 Seasonal mean value (13=DJF,14=MAM,15=JJA,16=SON)
;   imonth =  17 Mean of monthly values for user-defined set of months 
;
;   for imonth = 17 or -17, the following variables must be defined by user
;         n_mth = number of months over which average/sum is performed (1<n_mth<12)
;         v_mth = vector of n_mth components containing the month numbers to be taken 
;                 into account for the average/sum
;         lab_mth = string used to describe the period for the average/sum 
;                  (e.g., 'Nov-Feb' if average/sum is performed over months 11,12,1,2)
;
; When kplot is equal to -22 you can plot:
;   imonth = 1 GDD0
;   imonth = 2 GDD5
;
; When kplot is equal to -23 you can plot temperature extremes:
;   imonth = 1 Tdmin (minimum daily mean temperature)
;   imonth = 2 Tdmax (maximum daily mean temperature)
;   imonth = 3 Tdnmin (minimum night temperature)
;   imonth = 4 Tddmax (maximum diurnal temperature)
;   imonth = 5 Tmmin (mean (night old) temperature of the coldest month)
;   imonth = 6 Tmmax (mean (mid-day old) temperature of the warmest month)
;
;
; When kplot is equal to -56 you can plot wood production or crop yield (using yieldXXXX.res file):
;   imonth = 1 to nplant : PFT/species number for which yield is to be plotted
;
; When kplot is equal to -57 you can plot the number of PFTs/species:
;   imonth = 0 Use absolute NPP threshold to determine PFT/species presence
;   imonth = 1 Use relative NPP_plant/NPP_pix threshold to determine PFT/species presence
;
; When kplot is equal to -58 you can chose between :
;   imonth = 1 Daily Minimum Soil Water
;   imonth = 2 IBM Vegetation Cover Fraction
;   imonth = 3 Root Depth
;
; When kplot is equal to -59 you can chose between soil textures.
;   imonth = -1 sand content
;   imonth = -2 silt content
;   imonth = -3 clay content
;   imonth = -4 soil colour

; When kplot is equal to -61 you can chose between land use types
;   imonth = -1 total fraction
;   imonth = 0 mean fraction
;   imonth = 1 natural fraction
;   imonth = 2 crop fraction
;   imonth = 3 pasture fraction
;   imonth = 4 urban fraction
;   imonth = 5 rock fraction
;   imonth = 6 water fraction
 
; When kplot is equal to -62 you can chose between crop or pasture species
;   ncrop and npast are defined according to jbag value ; they must be set in jbag block  
;   imonth = -2 sum of pasture species fractions 
;   imonth = -1 sum of crop species fractions 
;   imonth = 0 sum of all species fractions (crop+pasture)
;   imonth = 1 to ncrop  crop species (potential) fractions
;   imonth = ncrop+1 ncrop+npast pasture species (potential) fractions 
;
; When kplot is equal to -63 you can plot annual mean biomass per land use:
;   imonth = 1 Biomass of herbs in natural vegetation
;   imonth = 2 Biomass of shrubs in natural vegetation
;   imonth = 3 Biomass of trees in natural vegetation
;   imonth = 4 Total biomass in natural vegetation 
;   imonth = 5 Biomass of crops 
;   imonth = 6 Biomass of pastures
;   imonth = 7 Total biomass
;
; When kplot is equal to -64 you can plot litter/soil carbon:
;   imonth = 1 Total (litter+soil C) in soil
;   imonth = 2 Total litter
;   imonth = 3 Leaf litter
;   imonth = 4 Structural (woody) litter
;   imonth = 5 Soil carbon 
; 
;
;==============================================================================
imonth = 6

; define n_mth, v_mth and lab_mth if imonth = 17 or imonth = -17
n_mth = 4
v_mth = [3,4,5,10]
lab_mth = 'MAMO'
;n_mth = 4
;v_mth = [11,12,1,2]
;lab_mth = 'NDJF'
;n_mth = 4
;v_mth = [6,7,8,9]
;lab_mth = 'JJAS'

; ==============================================================================
; kplot = -57 or kplot = 6 NPP threshold for presence 
; anppthres = absolute threshold (g C m-2 yr-1) (imonth = 0)
; rnppthres = relative threshold (NPP_species/NPP_pix) (imonth = 1)

anppthres = 150.
rnppthres = 0.01

; ==============================================================================
; kplot = 9 Biomass threshold for presence 
; anppthres = absolute threshold (kg C m-2) 

abiothres = 3.

; ==============================================================================
; kplot = -57 
;   num_spec = number of species to be considered
;   vec_spec = vector with the species ID (number) to be considered

;num_spec = 11 
;vec_spec = [1,2,3,4,5,6,7,8,9,10,11]
;lab_spec = 'understorey'

num_spec = 15 
vec_spec = [12,13,14,15,16,17,18,19,20,21,22,23,24,25,26]
lab_spec = 'overstorey'

;num_spec = 26 
;vec_spec = [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26]
;lab_spec = 'all PFTs'

;num_spec = 5 
;vec_spec = [3,4,5,6,7]
;lab_spec = 'overstorey'


;===============================================================================
;  user-defined plot (kplot=60)
;-------------------------------------------------------------------------------

if kplot eq -60 then begin
 labcolv=['']
 colnamev=['_biom']
 yeardata='2010'
  npix=17229
 user_plotname='SAT_'
; user_plotname='CARAIB_'
 user_graphname='Aboveground forest biomass '
 user_file='/work0/umccb/verma/Biomass/biomass_sum_'+yeardata+'.dat'
; user_file='../results/Wallonia/COSMO_lprtqv_varc_TRY9_CILU5_PT6_N2_TOL2/treebio'+yeardata+'.res' 
; user_file='/raid3/umccb/jacquemin/MASC/201805_LAInew_Belgium_ALRSFX/human_frac.dat' 
 user_jcol=1
;; user_labcol=labcolv(0)+yeardata+' (g C m!e-2!n) '
 user_labcol=labcolv(0)+yeardata+' (tons C per pixel of 1 km!e2!n) '
 user_colname=colnamev(0)
 user_ncol=1
 label = 'JRC data'
; label = 'CARAIB'
 icont=0
 strtime = '_'+yeardata+'_' 
 facmul = 0.5    ; facmul=0.45*1000000./10000.
; facmul=1
 dlg = 0.01400
 dlt = 0.00900
; output directory
 dirps='../ps/Wallonia/COSMO/lprtqv/caraib_TRY9_CILU5_PT6_N2_TOL2/' 
endif

;if kplot eq -60 then begin
; labcolv=['Elevation (m)']
; colnamev=['_elv']
; yeardata='1980'
;  npix=269676
; user_plotname='elv'
; user_graphname=''
; user_file='../COSMO/'+user_plotname+yeardata+'.dat' 
; user_jcol=irun
; user_labcol=labcolv(irun-1)
; user_colname=colnamev(irun-1)
; user_ncol=1
; label = ''
; icont=0
; strtime = '_'+yeardata+'_' 
; dlg = 0.0275
; dlt = 0.0275
;; output directory
; dirps='../ps/CE/' 
; icont = 1
;endif

;===============================================================================

;===============================================================================
; Are you sure the above parameters are correct? OK now you can run
; idl and make a map
;===============================================================================

;===============================================================================
; variables depending on iwin
;
; log1, log2 = minimum and maximum longitude;
; lat1, lat2 = minimum and maximum latitude;
; strrreg    = output file information about the geographic zone;
; labellign:
;    ktck_lab   = 0 for automatic labelling
;    ktck_lab   = 1 for user-defined labelling 
; nlong_grid = number of meridians plotted (?)
; nlat_grid  = number of parallels plotted (?)
; long_lab   = longitudinal labels;
; lat_lab    = latitudinal labels.
;===============================================================================
ymarup = 8
if iwin eq 0 then begin 
  log1=-180.
  log2= 180.
  lat1= -60.
  lat2=  90.
  strreg = '_GL'
  longlab = -35.
  latlab = -55.
  ktck_lab = 0
  nlat_grid = 5
  nlong_grid = 6
  ymarup=12
endif
if iwin eq 1 then begin 
  log1=-12.5
  log2= 45.
  lat1= 35.
  lat2= 72.
  strreg = '_EUR'
  longlab = -12.
  latlab = 73.
  ktck_lab = 1
   ; parallels  
     nlat_grid = 7
     lat_lab=[35,40,45,50,55,60,65,70]   ;nlat_grid+1 components
   ; meridians
     nlong_grid = 11
     long_lab=[-10,-5,0,5,10,15,20,25,30,35,40,45] ;nlong_grid+1 components
endif
if iwin eq 2 then begin 
  log1=-12.5
  log2= 30.
  lat1= 35.
  lat2= 65.
  strreg = '_WEur'
  longlab = -12.
  latlab = 66.
  ktck_lab = 1
   ; parallels  
     nlat_grid = 6
     lat_lab=[35,40,45,50,55,60,65]   ;nlat_grid+1 components
   ; meridians
     nlong_grid = 8
     long_lab=[-10,-5,0,5,10,15,20,25,30] ;nlong_grid+1 components  
endif
if iwin eq 3 then begin 
  log1= -15.
  log2= 45.
  lat1= 23.
  lat2= 72.
  strreg = '_EuAf'
  longlab = -12.
  latlab = 68.
  ktck_lab = 1
   ; parallels  
     nlat_grid = 9
     lat_lab=[25,30,35,40,45,50,55,60,65,70]   ;nlat_grid+1 components
   ; meridians
     nlong_grid = 12
     long_lab=[-15,-10,-5,0,5,10,15,20,25,30,35,40,45] ;nlong_grid+1 components
endif
if iwin eq 4 then begin 
  log1= -25.
  log2= 70.
  lat1= 30.
  lat2= 80.
  strreg = '_EURS'
  longlab = -38.  ;-20.8
  latlab = 85. ;69.5
  ktck_lab = 1
   ; parallels  
     nlat_grid = 10
     lat_lab=[30,35,40,45,50,55,60,65,70,75,80]   ;nlat_grid+1 components
   ; meridians
     nlong_grid = 8
     long_lab=[-20,-10,0,10,20,30,40,50,60,70] ;nlong_grid+1 components
endif
if iwin eq 5 then begin 
  log1= 42.
  log2= 58.
  lat1= -28.
  lat2= -8.
  strreg = '_Mdg'
  longlab = 43.
  latlab = -9.
  ktck_lab = 1
   ; parallels  
     nlat_grid = 10
     lat_lab=[-28,-26,-24,-22,-20,-18,-16,-14,-12,-10,-8]   ;nlat_grid+1 components
   ; meridians
     nlong_grid = 8
     long_lab=[42,44,46,48,50,52,54,56,58] ;nlong_grid+1 components
  ymarup = 5   
endif
if iwin eq 6 then begin 
  ymarup = 6
  log1= -20. ;0.
  log2= 60.
  lat1= 25.
  lat2= 70.   ;65.
  strreg = '_SEEur'
  longlab = log1+3
  latlab = lat2+8
  ktck_lab = 1
   ; parallels  
     nlat_grid = 9
     lat_lab=[25,30,35,40,45,50,55,60,65,70]   ;nlat_grid+1 components
   ; meridians
     nlong_grid = 8
     long_lab=[-20,-10,0,10,20,30,40,50,60] ;nlong_grid+1 components
endif
if iwin eq 7 then begin 
  log1= -45.0
  log2= -44.5
  lat1= -22.6
  lat2= -22.0
  strreg = '_Ita'
  longlab = -45.
  latlab = -21.96
  ktck_lab = 0
   ; parallels  
     nlat_grid = 8
     lat_lab=[36,37,38,39,40,41,42,43,44]   ;nlat_grid+1 components
   ; meridians
     nlong_grid = 7
     long_lab=[-10,-8,-6,-4,-2,0,2,4] ;nlong_grid+1 components
endif
if iwin eq 8 then begin 
  log1=-20.
  log2= 60.
  lat1= 0.
  lat2= 40.
  strreg = '_Sah'
  longlab = -19.
  latlab = 41.
  ktck_lab = 1
   ; parallels  
     nlat_grid = 8
     lat_lab=[0,5,10,15,20,25,30,35,40]   ;nlat_grid+1 components
   ; meridians
     nlong_grid = 8
     long_lab=[-20,-10,0,10,20,30,40,50,60] ;nlong_grid+1 components
  ymarup=20
endif
if iwin eq 9 then begin 
  log1=-10.
  log2= 10.
  lat1= 36.
  lat2= 60.
  strreg = '_WEur'
  longlab = 0.
  latlab = 57.6
  ktck_lab = 1
   ; parallels  
     nlat_grid = 12
     lat_lab=[36,38,40,42,44,46,48,50,52,54,56,58,60]   ;nlat_grid+1 components
   ; meridians
     nlong_grid = 10
     long_lab=[-10,-8,-6,-4,-2,0,2,4,6,8,10] ;nlong_grid+1 components
endif
if iwin eq 10 then begin 
  log1=  73.
  log2= 135.
  lat1=  18.
  lat2=  54.
  strreg = '_CHN'
  longlab = 21.
  latlab = 114.
  ktck_lab = 1
   ; parallels  
     nlat_grid = 6
     lat_lab=[20,25,30,35,40,45,50]   ;nlat_grid+1 components
   ; meridians
     nlong_grid = 12
     long_lab=[75,80,85,90,95,100,105,110,115,120,125,130,135] ;nlong_grid+1 components
endif
if iwin eq 11 then begin 
  log1= 2.5
  log2= 6.5
  lat1= 49.5
  lat2= 51.5
  strreg = '_Bel'
  longlab = 2.6
  latlab = 49.58
  ktck_lab = 1
   ; parallels  
     nlat_grid = 4
     lat_lab=[49.5,50,50.5,51,51.5]   ;nlat_grid+1 components
   ; meridians
     nlong_grid = 8
     long_lab=[2.5,3,3.5,4,4.5,5,5.5,6,6.5] ;nlong_grid+1 components
  ymarup = 19
endif
if iwin eq 12 then begin 
  log1= -20.
  log2= 52.
  lat1= -40.
  lat2= 38.
  strreg = '_AFR'
  longlab = -18.
  latlab = -39.
  ktck_lab = 1
   ; parallels  
     nlat_grid = 7
     lat_lab=[-40,-30,-20,-10,0,10,20,30]   ;nlat_grid+1 components
   ; meridians
     nlong_grid = 7
     long_lab=[-20,-10,0,10,20,30,40,50] ;nlong_grid+1 components
endif
if iwin eq 13 then begin 
  log1= 165.
  log2= 180.
  lat1= -50.
  lat2= -30.
  strreg = '_NZE'
  longlab = 167.
  latlab = -32.
  ktck_lab = 1
   ; parallels  
     nlat_grid = 4
     lat_lab=[-50,-45,-40,-35,-30]   ;nlat_grid+1 components
   ; meridians
     nlong_grid = 3
     long_lab=[165,170,175,180] ;nlong_grid+1 components
  ymarup = 8
endif
if iwin eq 14 then begin 
  log1= -60.
  log2= -34.
  lat1= -35.
  lat2= 0.
  strreg = '_BAF'
  longlab = -46.5
  latlab = -27.
  ktck_lab = 1
   ; parallels  
     nlat_grid = 7
     lat_lab=[-35,-30,-25,-20,-15,-10,-5,0]   ;nlat_grid+1 components
   ; meridians
     nlong_grid = 5
     long_lab=[-60,-55,-50,-45,-40,-35] ;nlong_grid+1 components
  ymarup = 6
endif
if iwin eq 15 then begin 
  log1= -20.
  log2= 180.
  lat1= 20.
  lat2= 80.
  strreg = '_EURAS'
  longlab = 100.
  latlab = 90.
  ktck_lab = 1
   ; parallels  
     nlat_grid = 6
     lat_lab=[20,30,40,50,60,70,80]   ;nlat_grid+1 components
   ; meridians
     nlong_grid = 13
     long_lab=[-15,0,15,30,45,60,75,90,105,120,135,150,165,180] ;nlong_grid+1 components
  ymarup = 18
endif
if iwin eq 16 then begin 
  log1= 4.61   ; 4.58
  log2= 4.84   ; 4.87
  lat1= 50.70
  lat2= 50.81  ;50.99
  strreg = '_EBBE'
  longlab = 0.
  latlab = 86.
  ktck_lab = 0
   ; parallels  
     nlat_grid = 7
     lat_lab=[35,40,45,50,55,60,65,70]   ;nlat_grid+1 components
   ; meridians
     nlong_grid = 11
     long_lab=[-25,-20,-15,-10,-5,0,5,10,15,20,25,30] ;nlong_grid+1 components
     ymarup = 5
endif
if iwin eq 17 then begin 
  log1= 12   
  log2= 32  
  lat1= -14
  lat2= 6  
  strreg = '_RDC'
  longlab = 22
  latlab = 7.
  ktck_lab = 1
   ; parallels  
     nlat_grid = 10
     lat_lab=[-14,-12,-10,-8,-6,-4,-2,0,2,4,6]   ;nlat_grid+1 components
   ; meridians
     nlong_grid = 10
     long_lab=[12,14,16,18,20,22,24,26,28,30,32] ;nlong_grid+1 components
     ymarup = 10
endif
if iwin eq 18 then begin 
  log1= -16.95   
  log2= -16.10  
  lat1= 27.90
  lat2= 28.6
  strreg = '_TEN'
  longlab = -16.92
  latlab = 28.55
  ktck_lab = 1
   ; parallels  
     nlat_grid = 6
     lat_lab=[27.9,28.0,28.1,28.2,28.3,28.4,28.5]   ;nlat_grid+1 components
   ; meridians
     nlong_grid = 7
     long_lab=[-16.9,-16.8,-16.7,-16.6,-16.5,-16.4,-16.3,-16.2] ;nlong_grid+1 components
     ymarup = 12
endif
if iwin eq 19 then begin 
  log1= -7.0   
  log2= -3.0 
  lat1= 32.0
  lat2= 36.0
  strreg = '_ATLAS'
  longlab = 36.9
  latlab = -7.0
  ktck_lab = 1
   ; parallels  
     nlat_grid = 4
     lat_lab=[32,33,34,35,36]   ;nlat_grid+1 components
   ; meridians
     nlong_grid = 4
     long_lab=[-7,-6,-5,-4,-3] ;nlong_grid+1 components
     ymarup = 15
endif
if iwin eq 20 then begin 
  log1= -72.0   
  log2= -56.0 
  lat1= -25.0
  lat2= -8.0
  strreg = '_Bol'
  longlab = -71.0
  latlab = -7.0
  ktck_lab = 0
   ; parallels  
     nlat_grid = 4
     lat_lab=[-25,-20,-15,-10,-5]   ;nlat_grid+1 components
   ; meridians
     nlong_grid = 4
     long_lab=[-75,-70,-65,-60,-55] ;nlong_grid+1 components
;     ymarup = 15
    ymarup = 8
endif
if iwin eq 21 then begin 
  log1= -10.0   
  log2= -5.0 
  lat1= 32.0
  lat2= 36.0
  strreg = '_Mor'
  longlab = -9.5
  latlab = 35.5
  ktck_lab = 1
   ; parallels  
     nlat_grid = 4
     lat_lab=[32,33,34,35,36]   ;nlat_grid+1 components
   ; meridians
     nlong_grid = 5
     long_lab=[-10,-9,-8,-7,-6,-5] ;nlong_grid+1 components
     ymarup = 15
endif
if iwin eq 22 then begin 
  log1= 2.0   
  log2= 10.0
  lat1= 49.0
  lat2= 53.0
  strreg = '_BenWG'
  longlab = 2.
  latlab = 53.2
  ktck_lab = 1
   ; parallels  
     nlat_grid = 4
     lat_lab=[49,50,51,52,53]   ;nlat_grid+1 components
   ; meridians
     nlong_grid = 8
     long_lab=[2,3,4,5,6,7,8,9,10] ;nlong_grid+1 components
     ymarup = 15
endif
if iwin eq 23 then begin 
  log1= 5.7   
  log2= 6.6
  lat1= 49.4
  lat2= 50.2
  strreg = '_Lux'
  longlab = 5.75
  latlab = 50.25
  ktck_lab = 1
   ; parallels  
     nlat_grid = 8
     lat_lab=[49.4,49.5,49.6,49.7,49.8,49.9,50,50.1,50.2]   ;nlat_grid+1 components
   ; meridians
     nlong_grid = 3
     long_lab=[5.75,6.0,6.25,6.5] ;nlong_grid+1 components
     ymarup = 8
endif
if iwin eq 24 then begin 
  log1= 1.5 
  log2= 18.
  lat1= 42.5
  lat2= 55.5
  strreg = '_CE'
  longlab = 1.
  latlab = 56.
  ktck_lab = 1
   ; parallels  
     nlat_grid = 5
     lat_lab=[44,46,48,50,52,54]   ;nlat_grid+1 components
   ; meridians
     nlong_grid = 8
     long_lab=[2.,4.,6.,8.,10.,12.,14.,16.,18.] ;nlong_grid+1 components
     ymarup = 8
endif
if iwin eq 25 then begin 
  log1= 2.5
  log2= 6.5
  lat1= 49.5
  lat2= 51.0
  strreg = '_Wal'
  longlab = 2.6
  latlab = 49.6
  ktck_lab = 1
   ; parallels  
     nlat_grid = 3
     lat_lab=[49.5,50,50.5,51]   ;nlat_grid+1 components
   ; meridians
     nlong_grid = 8
     long_lab=[2.5,3,3.5,4,4.5,5,5.5,6,6.5] ;nlong_grid+1 components
  ymarup = 24
endif
;===============================================================================
; variables depending on jbag (pft or BAG types)
;
;  ngrass   = number of grass/shrub types;
;  ntree    = number of tree types;
;  nspecies = number of species included in caraib;
;  strbag   = output file information about the BAG types.
;===============================================================================
nherb = 0
nshrb = 0
ntree = 0
ncrop = 0
npast = 0

if jbag eq 0 then begin
  nherb = 2
  nshrb = 0
  ntree = 15
  ncrop = 0
  npast = 0
  strbag='17BAG'
endif
if jbag eq 1 then begin
  nherb = 2
  nshrb = 0
  ntree = 13
  ncrop = 0
  npast = 0
  strbag='15pft'  
endif
if jbag eq 2 then begin
  nherb = 2
  ntree = 15
  ncrop = 2
  strbag='17BAGs'  
endif
if jbag eq 3 then begin
  nherb = 6
  nshrb = 7
  ntree = 13
  ncrop = 0
  npast = 0
  strbag='26BAG'
endif
if jbag eq 4 then begin
  nherb = 0
  nshrb = 0
  ntree = 1
  ncrop = 0
  strbag='Acacia'
endif
if jbag eq 5 then begin
  nherb = 13
  ntree = 13
  ncrop = 8
  strbag='species'
endif
if jbag eq 6 then begin
  nherb = 1
  ntree = 10
  nspecies = 0
  nshrb = 0
  strbag='AfrDec'
endif
if jbag eq 7 then begin
  nherb = 5
  nshrb = 2  
  ntree = 31
  nspecies = 0
  strbag='Afr'
endif
if jbag eq 8 then begin
  nherb = 3
  nshrb = 8
  ntree = 15
  ncrop = 0
  npast = 0
  strbag='26PFT'
  jbagtol = 1  
  filebagtol='/raid/umccb/francois/caraib_nc/plantparam/bagtol_26PFT_transient_3_mtco.dat'  
endif
if jbag eq 9 then begin
  nherb = 2
  ntree = 75
  nspecies = 0
  strbag='SAmFl'
endif
if jbag eq 10 then begin
  nherb = 9
  ntree = 91
  nspecies = 0
  nshrb = 6
  strbag='Afr_all'
  jbagtol = 1
  filebagtol='/raid3/umccb_raid1/henrot/VULPES/run_Cameroun/run_Cameroun_jan2018/caraib/plantparam/afrspecies_gswp3/bagtol_ALLspecies_q1_GSWP3_mixTdmin.dat'  
endif
if jbag eq 11 then begin
  nherb = 1
  nshrb = 1  
  ntree = 14
  ncrop = 12
  npast = 1
  strbag='BEL'
  jbagtol = 1  
  filebagtol='/raid3/umccb/clim0017/stufrancois/caraib_2020/caraib/plantparam/species_tol_t6.dat'  
endif
if jbag eq 12 then begin
  nherb = 3
  ntree = 12
  nspecies = 0
  strbag='Afr12'
  jbagtol = 1  
  filebagtol='/raid/umccb/clim0017/stumertens/caraib_nc/plantparam_esp/sim2/bagtol_Afr1_sim1.dat'  
endif
if jbag eq 13 then begin
  nherb = 3
  nshrb = 8
  ntree = 15
  ncrop = 16
  npast = 2
  strbag='GL44'
  jbagtol = 1  
  filebagtol='/raid/umccb/francois/caraib_nc/plantparam/bagtol_26PFT_transient_3.dat'
endif
if jbag eq 14 then begin
  nherb = 2
  ntree = 5
  nspecies = 0
  strbag='vulbr'
  jbagtol = 1  
  filebagtol='/raid3/umccb/francois/caraib/plantparam/bagtol_vulbr_q1_h.dat'
endif
if jbag eq 15 then begin
  nherb = 1
  ntree = 40
  nspecies = 0
  strbag='EUR40'
  jbagtol = 1  
  filebagtol='/raid3/umccb/migou/home/dury/dispersion/speciestest/tree100_tol_final_new.dat'
endif
if jbag eq 16 then begin
  nherb = 1
  ntree = 2
  nspecies = 0
  strbag='CedCQ'
  jbagtol = 1  
  filebagtol='/raid3/umccb/trolliet/Vulpes/run_juin2018/caraib01L//plantparam_pft/RMA/CQ/bagtol_cedrus_q1_CRU_WC1.dat'
endif
if jbag eq 17 then begin
  nherb = 3
  nshrb = 4  
  ntree = 3
  nspecies = 0
  strbag='Ara'
  jbagtol = 1  
  filebagtol='/raid3/umccb/clim0017/Ara1/mkspec/caraibfiles/bagtol_ara_q1.dat'
endif
if jbag eq 18 then begin
  nherb = 3
  nshrb = 0  
  ntree = 3
  ncrop = 5
  npast = 1
  strbag='Morsp'
  jbagtol = 1  
  filebagtol='/raid3/umccb/clim0017/stufrancois/caraib/plantparam/tol_mor.dat'
endif

;===============================================================================
;
; nplant = number of plants;
; nbag   = number of natural species/pfts;
  
  ngrass = nherb+nshrb
  nbag = nherb+nshrb+ntree
  nspecies = ncrop+npast
  nplant=nbag+nspecies

  
;  np_min=nplant-nspecies+1
  np_min=1
  np_max=nplant
;  np_max=nplant-nspecies
  
if (kplot eq -57) and (num_spec gt nplant) then begin
  print,'Number of species num_spec too large: ',num_spec,nplant
  print,'Program stop'
  stop
endif 

  
; number of biome classes
  nbiome=24
  


; nmonth = number of months
  nmonth = 12 
  mthn=['_yrm','_jan','_feb','_mar','_apr','_may','_jun','_jul','_aug','_sep','_oct','_nov','_dec','_DJF','_MAM','_JJA','_SON','_'+lab_mth]
  monthn=['Annual Mean','January','February','March','April','May','June','July','August','September','October','November','December','DJF','MAM','JJA','SON',lab_mth]
  mthname=''
  if kplot le -12 and kplot ge -20 then begin
   if imonth ge 0 then begin
     monthname=monthn(imonth)
     mthname= mthn(imonth)
   endif
   if imonth lt 0 then begin
     if imonth eq -1 then begin 
       monthname='Annual'
       mthname='_yr'
     endif
     if imonth eq -2 then begin 
       monthname='Maximum'
       mthname='_max'
     endif
     if imonth eq -3 then begin
       monthname='Minimum'
       mthname='_min'
     endif
     if (imonth le -13) and (imonth ge -17) then begin
       monthname=monthn(-imonth)+ ' Sum '
       mthname='_Sum'+mthn(-imonth)
     endif     
   endif
    
  endif
  
  if kplot eq -22 then begin

     if imonth eq 1 then begin 
       monthname='0'
       mthname='0'
     endif else begin 
       monthname='5'
       mthname='5'
     endelse
  
  endif
  
  if kplot eq -23 then begin
;   imonth = 1 Tdmin (minimum daily mean temperature)
;   imonth = 2 Tdmax (maximum daily mean temperature)
;   imonth = 3 Tdnmin (minimum night temperature)
;   imonth = 4 Tddmax (maximum diurnal temperature)
     if imonth eq 1 then begin 
       monthname='(minimum daily mean temperature)'
       mthname='_Tdmin'
     endif
     if imonth eq 2 then begin 
       monthname='(maximum daily mean temperature)'
       mthname='_Tdmax'
     endif
     if imonth eq 3 then begin
       monthname='(minimum night temperature)'
       mthname='_Tdnmin'
     endif
     if imonth eq 4 then begin
       monthname='(maximum diurnal temperature)'
       mthname='_Tddmax'
     endif
     if imonth eq 5 then begin
       monthname='(Tmmin)'
       mthname='_Tmmin'
     endif     
     if imonth eq 6 then begin
       monthname='(Tmmax)'
       mthname='_Tmmax'
     endif             
  endif  
  
  if kplot le -24 and kplot ge -55 then begin
   if imonth ge 0 then begin
     monthname=monthn(imonth)
     mthname= mthn(imonth)
   endif
   if imonth lt 0 then begin
     if imonth eq -1 then begin 
       monthname='Annual'
       mthname='_yr'
     endif
     if imonth eq -2 then begin 
       monthname='Maximum'
       mthname='_max'
     endif
     if imonth eq -3 then begin
       monthname='Minimum'
       mthname='_min'
     endif
     if (imonth le -13) and (imonth ge -17) then begin
       monthname=monthn(-imonth)+ ' Sum '
       mthname='_Sum'+mthn(-imonth)
     endif     
   endif
    
  endif
  
  if kplot eq -56 then begin
     mthname='_sp'+strtrim(string(imonth),2)    
  endif     
  
  if kplot eq -58 then begin
     if imonth eq 1 then begin 
       monthname='Minimum Daily Soil Water (SW-WP)/(FC-WP)'
       mthname='_swdmin'
     endif
     if imonth eq 2 then begin 
       monthname='Vegetation Cover Fraction in IBM'
       mthname='_IBMfveg'
     endif
     if imonth eq 3 then begin
       monthname='Root Depth (mm)'
       mthname='_rootd'
     endif    
  endif     
    
  if kplot eq -59 then begin 
     if imonth eq -1 then begin 
       monthname='sand content'
       mthname='_sand'
     endif
     if imonth eq -2 then begin 
       monthname='silt content'
       mthname='_silt'
     endif
     if imonth eq -3 then begin
       monthname='clay content'
       mthname='_clay'
     endif
     if imonth eq -4 then begin
       monthname='soil colour'
       mthname='_scol'
     endif        
  endif
    
  if kplot eq -60 then mthname=user_colname  

  if kplot eq -61 then begin 
     if imonth eq -1 then begin 
       monthname='Total fraction'
       mthname='_total'
     endif
     if imonth eq 0 then begin 
       monthname='Mean fraction'
       mthname='_mean'
     endif       
     if imonth eq 1 then begin 
       monthname='Natural vegetation'
       mthname='_natveg'
     endif
     if imonth eq 2 then begin 
       monthname='Crops'
       mthname='_crop'
     endif
     if imonth eq 3 then begin
       monthname='Pastures'
       mthname='_past'
     endif
     if imonth eq 4 then begin
       monthname='Urban'
       mthname='_urb'
     endif
     if imonth eq 5 then begin
       monthname='Rock'
       mthname='_rock'
     endif
     if imonth eq 6 then begin
       monthname='Water'
       mthname='_water'
     endif                  
  endif
  
  if kplot eq -62 then begin
     if imonth gt 0 then begin
       if imonth le 9 then forms = '(i1)' else forms = '(i2)'  
       if imonth le ncrop then begin  
	  mthname='_c'+string(imonth,format=forms)+'_' 
	  monthname=''
       endif else begin
	  mthname='_p'+string(imonth,format=forms)+'_' 
	  monthname=''	        
       endelse 
     endif else begin
       monthname=''
       if imonth eq 0 then mthname = '_sumc&p_'
       if imonth eq -1 then mthname = '_sumc_'
       if imonth eq -2 then mthname = '_sump_' 
     endelse      
  endif
  
  if kplot eq -63 then begin 
     if imonth eq 1 then begin 
       monthname='Herbs'
       mthname='_herb'
     endif       
     if imonth eq 2 then begin 
       monthname='Shrubs'
       mthname='_shrub'
     endif
     if imonth eq 3 then begin
       monthname='Trees'
       mthname='_tree'
     endif
     if imonth eq 4 then begin
       monthname='Natural vegetation'
       mthname='_nat'
     endif
     if imonth eq 5 then begin
       monthname='Crops'
       mthname='_crop'
     endif
     if imonth eq 6 then begin
       monthname='Pastures'
       mthname='_past'
     endif
     if imonth eq 7 then begin
       monthname='Total'
       mthname='_total'
     endif                       
  endif  

  if kplot eq -64 then begin 
     if imonth eq 1 then begin 
       monthname='Total Litter and Soil'
       mthname='_total'
     endif       
     if imonth eq 2 then begin 
       monthname='Litter'
       mthname='_tlit'
     endif
     if imonth eq 3 then begin
       monthname='Leaf Litter'
       mthname='_llit'
     endif
     if imonth eq 4 then begin
       monthname='Strctural (Woody) Litter'
       mthname='_wlit'
     endif
     if imonth eq 5 then begin
       monthname='Soil'
       mthname='_SOC'
     endif           
  endif      
     
if kplot le 0 then imin=1 else imin=np_min
if kplot le 0 then imax=1 else imax=np_max

;===============================================================================
; loop over plant types.
;===============================================================================

for iplant = imin, imax do begin

  if iplant lt 10 then iplnum='0'+string(format='(i1)',string(iplant)) $
      else iplnum=string(format='(i2)',string(iplant))
        

  if kplot le 0 then begin
   if kplot eq -64 then plotname='soilC' 
   if kplot eq -63 then plotname='bio_yr'  
   if kplot eq -62 then plotname='cropf'  
   if kplot eq -61 then plotname='LUf' 
   if kplot eq -60 then plotname=user_plotname  
   if kplot eq -59 then plotname='soiltext'
   if kplot eq -58 then plotname='IBM' 
   if kplot eq -57 then plotname='spnum'+'_'+lab_spec   
   if kplot eq -56 then plotname='yield'
   if kplot eq -55 then plotname='cwth'
   if kplot eq -54 then plotname='pco2soil'
   if kplot eq -53 then plotname='lpr'
   if kplot eq -52 then plotname='qv'     
   if kplot eq -41 then plotname='bio_mth'   
   if kplot eq -40 then plotname='rn'   
   if kplot eq -39 then plotname='fsol'   
   if kplot eq -38 then plotname='snd'    
   if kplot eq -37 then plotname='xle'   
   if kplot eq -36 then plotname='xh'    
   if kplot eq -35 then plotname='ts'   
   if kplot eq -34 then plotname='sw_mth'   
   if kplot eq -33 then plotname='run'  
   if kplot eq -32 then plotname='aet'
   if kplot eq -31 then plotname='pet'   
   if kplot eq -30 then plotname='alb'  
   if kplot eq -29 then plotname='wnd'
   if kplot eq -28 then plotname='rhu'
   if kplot eq -27 then plotname='shr'
   if kplot eq -26 then plotname='prc'
   if kplot eq -25 then plotname='dte'
   if kplot eq -24 then plotname='tem'    
   if kplot eq -23 then plotname='tem'  
   if kplot eq -22 then plotname='GDD'
   if kplot eq -21 then plotname='elev'
   if kplot eq -20 then plotname='nbp_mth'
   if kplot eq -19 then plotname='ra_mth'
   if kplot eq -18 then plotname='nep_mth'
   if kplot eq -17 then plotname='GPP_mth'
   if kplot eq -16 then plotname='NPP_mth'
   if kplot eq -15 then plotname='LAI_mth'
   if kplot eq -14 then plotname='fburn'
   if kplot eq -13 then plotname='aburn'
   if kplot eq -12 then plotname='pfire'
   if kplot eq -11 then plotname='taufire'
   if kplot eq -10 then plotname='NPPgrass'  
   if kplot eq -9 then plotname='Cveg'
   if kplot eq -8 then plotname='Csoil'  
   if kplot eq -7 then plotname='Ctot'  
   if kplot eq -6 then plotname='dc13' 
   if kplot eq -5 then plotname='biome'
   if kplot eq -4 then plotname='LAI_tree' 
   if kplot eq -3 then plotname='LAI_pix'
   if kplot eq -2 then plotname='rnpp_tree'
   if kplot eq -1 then plotname='pftdom'
   if kplot eq  0 then plotname='NPPpix'
  endif else begin
   if kplot eq  1 then plotname='NPP'+iplnum 
   if kplot eq  2 then plotname='frac'+iplnum
   if kplot eq  3 then plotname='rnpp'+iplnum
   if kplot eq  4 then plotname='fnpp'+iplnum
   if kplot eq  5 then plotname='frc13'+iplnum
   if kplot eq  6 then plotname='dist'+iplnum
   if kplot eq  7 then plotname='Cveg'+iplnum
   if kplot eq  8 then plotname='fCveg'+iplnum
   if kplot eq  9 then plotname='ElvRange'+iplnum
   if kplot eq 10 then plotname='yield'+iplnum             
  endelse
  
  idfile=strtime+strbag+strreg 
  
  if ksite eq 0 then idsite='' else idsite='sitcp'
  if jdis eq 0 then iddis='' else iddis='_dis'
  if ianom eq 0 then fileps=dirps+plotname+mthname+idfile+idsite+iddis+'.eps'
  if ianom eq 1 then fileps=dirps+'an'+plotname+mthname+idfile+idsite+iddis+'.eps'
  if ianom eq 2 then fileps=dirps+'if'+plotname+mthname+idfile+idsite+iddis+'.eps'
  
   epsopen,file=fileps,/po,/psf,xs=19,ys=14

;   print,fileps
 
   device,/color

; igraph = -64 Litter/soil carbon (g C m-2)
; igraph = -63 Biomass (g C m-2)
; igraph = -62 Crop/Pasture fraction
; igraph = -61 Land use fraction
; igraph = -60 User-defined
; igraph = -59 Soil texture (sand, silt clay)
; igraph = -58 Daily Minimum SW, IBM Vegetation Cover Fraction, Root depth
; igraph = -57 Number of PFTs with NPP>thres
; igraph = -56 Wood production or crop yield (t/ha/yr)
; igraph = -55 Monthly/annual carbonate weathering rate (mol Ca/m2/mo mol Ca/m2/yr)
; igraph = -54 Monthly/annual soil PCO2 (ppmv)
; igraph = -53 Monthly/annual lapse rate (C/km)
; igraph = -52 Monthly/annual specific humidity (g/kg)
; igraph = -41 Monthly/annual biomass (g C m-2)
; igraph = -40 Monthly/annual net radiation flux Rn (W m-2)
; igraph = -39 Monthly/annual global solar radiation flux (W m-2)
; igraph = -38 Monthly/annual snow depth (mm)
; igraph = -37 Monthly/annual latent heat flux (W m-2)
; igraph = -36 Monthly/annual sensible heat flux (W m-2)
; igraph = -35 Monthly/annual surface temperature (C)
; igraph = -34 Monthly Soil Water (SW-WP)/(FC-WP)
; igraph = -33 Monthly/annual runoff (mm/mo mm/yr)
; igraph = -32 Monthly/annual AET (mm/mo mm/yr)
; igraph = -31 Monthly/annual PET (mm/mo mm/yr)
; igraph = -30 Monthly/annual albedo (0-1)
; igraph = -29 Monthly/annual mean wind speed (m/s)
; igraph = -28 Monthly/annual mean air relative humidity (%)
; igraph = -27 Monthly/annual mean sunshine hours (%)
; igraph = -26 Monthly/annual precipitation (mm/mo mm/yr)
; igraph = -25 Monthly/annual mean diurnal temperature range (C)
; igraph = -24 Monthly/annual mean air temperature (C) 
; igraph = -23 Daily temperature extremes (Tdmin,Tdmax,Tdnmin,Tddmax,Tmmin,Tmmax)
; igraph = -22 GDD0 or GDD5
; igraph = -21 Elevation
; igraph = -20 Monthly NBP (g m-2 mo-1)
; igraph = -19 Monthly Ra (g m-2 mo-1) 
; igraph = -18 Monthly NEP (g m-2 mo-1)
; igraph = -17 Monthly GPP (g m-2 mo-1)
; igraph = -16 Monthly NPP (g m-2 mo-1)
; igraph = -15 Monthly LAI (m2/m2)
; igraph = -14 Percentage of pixel area burned (%)
; igraph = -13 Area burned per pixel (ha)
; igraph = -12 Probability of fire (per 1000 km2 and per month)
; igraph = -11 Fire return interval (yr)   
; igraph = -10 NPP of grasses and shrubs  
; igraph = -9 Vegetation carbon
; igraph = -8 Litter & Soil Carbon
; igraph = -7 Total Carbon  
; igraph = -6 d13C map
; igraph = -5 Biome map
; igraph = -4 LAI of trees (max)
; igraph = -3 LAI of the pixel (max)
; igraph = -2 R=NPP(tree)/(NPP(grass)+NPP(tree)) 
; igraph = -1 Dominant PFT
; igraph = 0  Mean pixel NPP
; igraph = 1 to nplant             NPP of PFTs 1 to nplant
; igraph = nplant+1 to 2*nplant    Cover fraction in veg storey of PFTs 1 to nplant
; igraph = 2*nplant+1 to 3*nplant  Contribution to local NPP of PFTs 1 to nplant
; igraph = 3*nplant+1 to 4*nplant  frac*NPP of PFTs 1 to nplant
; igraph = 4*nplant+1 to 5*nplant  13C fractionation of PFTs 1 to nplant
; igraph = 5*nplant+1 to 6*nplant  Distribution (pres/abs) of PFTs 1 to nplant
; igraph = 6*nplant+1 to 7*nplant  Carbon biomass of PFTs 1 to nplant
; igraph = 7*nplant+1 to 8*nplant  frac*biomass of PFTs 1 to nplant
; igraph = 8*nplant+1 to 9*nplant  Elevation range of PFTs 1 to nplant
; igraph = 9*nplant+1 to 10*nplant Yields of PFTs 1 to nplant

  if kplot le 0 then begin
   igraph = kplot
  endif else begin
   igraph = (kplot-1)*nplant+iplant
  endelse
  if kplot eq -1 then nplant=nbag
  


  
; dim0 = npix = number of pixels in file  
  dim0 = long(npix)
  
; dim1 = number of plant types
  dim1 = long(nplant)  
  



; variable name & graph name to be printed on top of map
if igraph eq -64 then graphname= monthname+' Carbon (g C m!e-2!n)'
if igraph eq -63 then graphname='Biomass (g C m!e-2!n)'+' ['+monthname+']'
if igraph eq -62 then graphname='Crop/pasture fraction: '
if igraph eq -61 then graphname='Land use fraction: '+monthname
if igraph eq -60 then graphname=user_graphname+' '+user_labcol
if igraph eq -59 then graphname='Soil texture: '+monthname+' (%)'
if igraph eq -58 then graphname='IBM results: '+monthname
if igraph eq -57 then graphname='Number of PFTs/species: '+lab_spec
if igraph eq -56 then graphname='Yield (t ha!u-1!n yr!u-1!n) '
if igraph eq -55 then begin
  graphname='Carbonate weathering rate (mol Ca m!e-2!n mo!e-1!n)'+' ['+monthname+']'
  if imonth eq -1 then graphname='Carbonate weathering rate (mol Ca m!e-2!n yr!e-1!n)'+' ['+monthname+']'
  if (imonth le -13) and (imonth ge -17) then graphname='Carbonate weathering rate (mol Ca m!e-2!n)'+' ['+monthname+']'
endif
if igraph eq -54 then graphname='Soil PCO!i2!n (ppmv)'+' ['+monthname+']'
if igraph eq -53 then graphname='Temperature Lapse Rate (!eo!nC/km)'+' ['+monthname+']'
if igraph eq -52 then graphname='Specific Humidity (g/kg)'+' ['+monthname+']'
if igraph eq -41 then graphname='Biomass (g C m!e-2!n)'+' ['+monthname+']'
if igraph eq -40 then graphname='Net Radiation (W m!e-2!n)'+' ['+monthname+']'
if igraph eq -39 then graphname='Global Solar Radiation (W m!e-2!n)'+' ['+monthname+']'
if igraph eq -38 then graphname='Snow Depth (mm)'+' ['+monthname+']'
if igraph eq -37 then graphname='Latent Heat Flux (W m!e-2!n)'+' ['+monthname+']'
if igraph eq -36 then graphname='Sensible Heat Flux (W m!e-2!n)'+' ['+monthname+']'
if igraph eq -35 then graphname='Surface Temperature (!eo!nC)'+' ['+monthname+']'
if igraph eq -34 then graphname='Soil Water (SW-WP)/(FC-WP)'+' ['+monthname+']'
if igraph eq -33 then begin
  graphname='Runoff (mm/mo)'+' ['+monthname+']'
  if imonth eq -1 then graphname='Runoff (mm/yr)'+' ['+monthname+']'
  if (imonth le -13) and (imonth ge -17) then graphname='Runoff (mm)'+' ['+monthname+']'
endif
if igraph eq -32 then begin
  graphname='AET (mm/mo)'+' ['+monthname+']'
  if imonth eq -1 then graphname='AET (mm/yr)'+' ['+monthname+']'
  if (imonth le -13) and (imonth ge -17) then graphname='AET (mm)'+' ['+monthname+']'
endif  
if igraph eq -31 then begin
  graphname='PET (mm/mo)'+' ['+monthname+']'
  if imonth eq -1 then graphname='PET (mm/yr)'+' ['+monthname+']'
  if (imonth le -13) and (imonth ge -17) then graphname='PET (mm)'+' ['+monthname+']'
endif  
if igraph eq -30 then graphname='Albedo'+' ['+monthname+']'
if igraph eq -29 then graphname='Wind speed (m/s)'+' ['+monthname+']'
if igraph eq -28 then graphname='Air relative humidity (%)'+' ['+monthname+']'
if igraph eq -27 then graphname='Sunshine hours (%)'+' ['+monthname+']'
if igraph eq -26 then begin
  graphname='Precipitation (mm/mo)'+' ['+monthname+']'
  if imonth eq -1 then graphname='Precipitation (mm/yr)'+' ['+monthname+']'
  if (imonth le -13) and (imonth ge -17) then graphname='Precipitation (mm)'+' ['+monthname+']'
endif  
if igraph eq -25 then graphname='Diurnal temperature range (!eo!nC)'+' ['+monthname+']'
if igraph eq -24 then graphname='Air temperature (!eo!nC)'+' ['+monthname+']' 
if igraph eq -23 then graphname='Extreme temperature !c'+monthname+' (!eo!nC)'
if igraph eq -22 then graphname='GDD'+monthname+' (degree-day)'
if igraph eq -21 then graphname='Land elevation (m)'

if igraph eq -20 then begin
  graphname='NBP (g C m!e-2!n mo!e-1!n)'+' ['+monthname+']'
  if imonth eq -1 then graphname='NBP (g C m!e-2!n yr!e-1!n)'+' ['+monthname+']'
  if (imonth le -13) and (imonth ge -17) then graphname='NBP (g C m!e-2!n)'+' ['+monthname+']'
endif
if igraph eq -19 then begin
  graphname='Ra (g C m!e-2!n mo!e-1!n)'+' ['+monthname+']'
  if imonth eq -1 then graphname='Ra (g C m!e-2!n yr!e-1!n)'+' ['+monthname+']'
  if (imonth le -13) and (imonth ge -17) then graphname='Ra (g C m!e-2!n)'+' ['+monthname+']'
endif
if igraph eq -18 then begin
  graphname='NEP (g C m!e-2!n mo!e-1!n)'+' ['+monthname+']'
  if imonth eq -1 then graphname='NEP (g C m!e-2!n yr!e-1!n)'+' ['+monthname+']'
  if (imonth le -13) and (imonth ge -17) then graphname='NEP (g C m!e-2!n)'+' ['+monthname+']'
endif
if igraph eq -17 then begin
  graphname='GPP (g C m!e-2!n mo!e-1!n)'+' ['+monthname+']'
  if imonth eq -1 then graphname='GPP (g C m!e-2!n yr!e-1!n)'+' ['+monthname+']'
  if (imonth le -13) and (imonth ge -17) then graphname='GPP (g C m!e-2!n)'+' ['+monthname+']'
endif
if igraph eq -16 then begin
  graphname='NPP (g C m!e-2!n mo!e-1!n)'+' ['+monthname+']'
  if imonth eq -1 then graphname='NPP (g C m!e-2!n yr!e-1!n)'+' ['+monthname+']'
  if (imonth le -13) and (imonth ge -17) then graphname='NPP (g C m!e-2!n)'+' ['+monthname+']'
endif
if igraph eq -15 then graphname='LAI (m!e2!n m!e-2!n)'+' ['+monthname+']'
if igraph eq -14 then graphname='Percentage of pixel area burned (%)'+' ['+monthname+']'
if igraph eq -13 then graphname='Area burned per pixel (ha)'+' ['+monthname+']'
if igraph eq -12 then graphname='Probability of fire (per 1000 km!e-2!n)'+' ['+monthname+']'
if igraph eq -11 then graphname='Fire return interval (yr)'
if igraph eq -10 then graphname='Understorey (herbs+shrubs) NPP (g C m!e-2!n)'
if igraph eq -9 then graphname='Vegetation Carbon (kg C m!e-2!n)'
if igraph eq -8 then graphname='Litter & Soil Carbon (kg C m!e-2!n)'
if igraph eq -7 then graphname='Total Carbon (kg C m!e-2!n)'
if igraph eq -6 then graphname='Average Delta !e13!nC (!eo!n/!ioo!n)'  
if igraph eq -5 then graphname='Biome Distribution'
if igraph eq -4 then graphname='Maximum LAI of Trees'
if igraph eq -3 then graphname='Maximum LAI of the pixel'
if igraph eq -2 then graphname='Contribution of Trees to Local NPP (%) ' 
if igraph eq -1 then graphname='Dominant PFT '
if igraph eq 0 then graphname='NPP (g C m!u-2!n yr!u-1!n) '
if (igraph ge 1) and (igraph le nplant) then graphname='PFT NPP (g C m!u-2!n yr!u-1!n) '
if (igraph ge nplant+1) and (igraph le 2*nplant) then graphname='PFT Cover Fraction in Veg. Storey'
if (igraph ge 2*nplant+1) and (igraph le 3*nplant) then graphname='PFT Contribution to Local NPP (%) ' 
if (igraph ge 3*nplant+1) and (igraph le 4*nplant) then graphname='PFT f*NPP (g C m!u-2!n yr!u-1!n) '
if (igraph ge 4*nplant+1) and (igraph le 5*nplant) then graphname='PFT !e13!nC fractionation (!eo!n/!ioo!n) '
if (igraph ge 5*nplant+1) and (igraph le 6*nplant) then graphname='Plant distribution (pres/abs) '
if (igraph ge 6*nplant+1) and (igraph le 7*nplant) then graphname='PFT Biomass (kg C m!u-2!n)  '
if (igraph ge 7*nplant+1) and (igraph le 8*nplant) then graphname='PFT f*Biomass (kg C m!u-2!n)  '
if (igraph ge 8*nplant+1) and (igraph le 9*nplant) then graphname='PFT Elevation Range (m)  '
if (igraph ge 9*nplant+1) and (igraph le 10*nplant) then graphname='PFT yield (t/ha)  '

; ============ DEFINITION OF VARIABLE RANGES (DIVISIONS) FOR COLOR SCALE ==================================

; continuous scaling (iclass=0) or discrete scaling (iclass=1)
  iclass = 0
  
; dircol=1 increasing color scale (from violet/blue to red/brown)
; dircol=-1 decreasing color scale (from brown/red to blue/violet)
  dircol= 1  

; jplalldiv : allows to plot legend of color scale only for variable ranges that actually exist in the data
;     (e.g., this allows to avoid plotting a legend for biomes/pft that do not exist in the plotted area)
;     jplalldiv = 1 plots in the legend all color scale divisions
;     jplalldiv = 0 plots in the legend only color scale divisions that actually exist in the data 
; A standard value (1) of jplalldiv can be set here and then may be changed selectively according to 
; variable which is plotted in the sequence of "if igraph" statements below
  jplalldiv = 1

  
; ndiv: number of colors to use for the color scale (max=14)

; limits for color scale (ndiv+1 values)

kgrey = 0
zerogrey = 0
zerocol = 0
zeroleg=''

if (igraph eq -64) then begin
 if ianom eq 0 then begin
  ndiv = 17
  inoveg = 0  
  xtic  = [0,50,100,200,500,1000,1500,2000,2500,3000,4000,5000,6000,7000,8000,9000,10000,12000,14000,16000,18000,20000]    ;biommth
;  xtic  = [0,500,1000,1500,2000,2500,3000,3500,4000,4500,5000,5500,6000,6500,7000,7500,8000,8500,9000,9500,10000,10500,11000]
 
  midtic = ' - '
  lowtic = '  '
  hightic = ' > '
  formtic = 'i6' 
 endif else begin
    inoveg = 0
;    ndiv = 15
;    xtic  = [-2000,-1500-1000,-600,-400,-200,-100,-50,50,200,500,1000,2000,5000] ;anom biommth
   xtic = [-3000,-2000,-1500,-1000,-800,-600,-500,-400,-300,-200,-100,-0.4,0.4,100,200,300,400,500,600,800,1000,1500,2000,3000]  ;LU fraction difference  
   midtic = ' : '
   lowtic = ' < '
   hightic = ' > '
   formtic = 'i6' 
   dircol = 1 
   zerogrey = 1
   zerocol = 13
   zeroleg = ' 0 '
 endelse 
endif
if (igraph eq -63) then begin
 if ianom eq 0 then begin
  ndiv = 17
  inoveg = 0  
  xtic  = [0,20,50,100,200,500,1000,1500,2000,3000,4000,6000,8000,10000,15000,20000,25000,30000]    ;biommth
  xtic  = [0,500,1000,1500,2000,2500,3000,3500,4000,4500,5000,5500,6000,6500,7000,7500,8000,8500,9000,9500,10000,10500,11000]
 
  midtic = ' - '
  lowtic = '  '
  hightic = ' > '
  formtic = 'i6' 
 endif else begin
    inoveg = 0
;    ndiv = 15
;    xtic  = [-2000,-1500-1000,-600,-400,-200,-100,-50,50,200,500,1000,2000,5000] ;anom biommth
   xtic = [-3000,-2000,-1500,-1000,-800,-600,-500,-400,-300,-200,-100,-0.4,0.4,100,200,300,400,500,600,800,1000,1500,2000,3000]  ;LU fraction difference  
   midtic = ' : '
   lowtic = ' < '
   hightic = ' > '
   formtic = 'i6' 
   dircol = 1 
   zerogrey = 1
   zerocol = 13
   zeroleg = ' 0 '
 endelse 
endif

if (igraph eq -61) or (igraph eq -62) then begin
  inoveg = 0 
  if ianom eq 0 then begin  
   xtic = [0.002,0.05,0.10,0.15,0.20,0.25,0.30,0.35,0.40,0.45,0.50,0.55,0.60,0.65,0.70,0.75,0.80,0.85,0.90,0.95,0.998]  ;LU fraction
   midtic = ' - '
   lowtic = '  '
   hightic = '  '
   formtic = 'f5.2' 
   dircol = 1 
   zerogrey = 1
   zerocol = 1
   zeroleg='    0.00 '
  endif else begin
   xtic = [-0.30,-0.20,-0.15,-0.10,-0.08,-0.06,-0.05,-0.04,-0.03,-0.02,-0.01,-0.001,0.001,0.01,0.02,0.03,0.04,0.05,0.06,0.08,0.10,0.15,0.20,0.30]  ;LU fraction difference  
   midtic = ' : '
   lowtic = ' < '
   hightic = ' > '
   formtic = 'f5.2' 
   dircol = 1 
   zerogrey = 1
   zerocol = 13
   zeroleg = ' 0.00 '
  endelse   
endif
if igraph eq -60 then begin
  ndiv = 19
  inoveg = 0  
;  xtic  = [-200,0,15,30,45,59,74,90,105,120,135,150,165,180,195,210,225,240,255,270,285,300,315,330,345]    ;day number
;  xtic  = [0.001,0.05,0.10,0.15,0.20,0.25,0.30,0.35,0.40,0.45,0.50,0.55,0.60,0.65,0.70,0.75,0.80,0.85,0.90,0.95]    ;crop proportion
;  xtic  = [0.0,1,1.5,2,2.5,3,3.5,4,4.5,5,5.5,6,6.5,7,7.5,8,8.5,9,9.5,10,10.5,11]
;    xtic  = [0.0,10,20,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,48,50]
;        xtic  = [0.0,10,20,30,40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,58]
; xtic  = [-50,-20,0,50,100,200,300,400,600,800,1000,1200,1400,1600,1800,2000,2500,3000,4000,5000]
; xtic  = [0,100,200,500,1000,2000,3000,4000,5000,6000,7000,8000,9000,10000,11000,12000,13000,14000,15000,20000,25000,30000]
  xtic  = [100,500,1000,1500,2000,2500,3000,3500,4000,4500,5000,5500,6000,6500,7000,7500,8000,8500,9000,9500,10000,10500,11000]
  midtic = ' - '
  lowtic = ' < '
  hightic = ' > '
;  formtic = 'f5.2'
  formtic = 'i5'  
endif
if (igraph eq -59) then begin
  ndiv = 16
  inoveg = 0 
  xtic = [10,15,20,25,30,35,40,45,50,55,60,65,70,75,80,85,90]  ;sand, silt, clay soil content
  midtic = ' - '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'i3' 
  dircol = 1 
endif
if (igraph eq -58) then begin
 if (imonth eq 1) then begin
  ndiv = 16
  inoveg = 0 
;  xtic = [0.01,0.02,0.04,0.06,0.08,0.1,0.15,0.2,0.25,0.3,0.4,0.5,0.6,0.8,1.0,1.2,1.4]  ;SW
  xtic = [0.01,0.02,0.03,0.04,0.06,0.08,0.1,0.12,0.14,0.16,0.18,0.2,0.3,0.4,0.6,0.8,1.0]  ;SW
  midtic = ' - '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'f6.2' 
  dircol = -1
 endif
 if (imonth eq 2) then begin 
  ndiv = 13
  inoveg = 0  
  xtic = [0.00,0.05,0.10,0.15,0.20,0.25,0.30,0.40,0.50,0.60,0.70,0.8,0.9,1.0]  ;frac
  midtic = ' - '
  lowtic = ' '
  hightic = ' '
  formtic = 'f4.2' 
 endif 
 if (imonth eq 3) then begin 
  if ianom eq 0 then begin
    ndiv = 16
    inoveg = 0  
    xtic = [100,200,300,400,500,600,700,800,900,1000,1100,1200,1300,1400,1500,1600,1700]  ;root depth
    midtic = ' - '
    lowtic = ' < '
    hightic = ' > '
    formtic = 'i4' 
  endif
  if ianom eq 1 then begin
    ndiv = 19
    inoveg = 0  
    xtic = [-1000,-800,-600,-400,-300,-200,-100,-50,-20,-10,10,20,50,100,200,300,400,600,800,1000]  ;root depth anomaly
    midtic = ' to '
    lowtic = ' < '
    hightic = ' > '
    formtic = 'i6'
  endif   
 endif
endif
if igraph eq -57 then begin
 if ianom eq 0 then begin
  ndiv = num_spec-1
  inoveg = 0 
  xtic = fltarr(num_spec)
  for k = 0, num_spec-1 do xtic(k)=k+0.5    ;number of species
  midtic = ' - '
  lowtic = '  '
  hightic = '  '
  formtic = 'i3'
  ibw=0  
 endif else begin
  ndiv = 13
  inoveg = 0  
  xtic  = [-6.5,-5.5,-4.5,-3.5,-2.5,-1.5,-0.5,0.5,1.5,2.5,3.5,4.5,5.5,6.5]    ;number of species difference
  midtic = ' - '
  lowtic = '  '
  hightic = ' > '
  formtic = 'i2'
  ibw=0 
 endelse
 iclass = 1
 tic_lab=strarr(ndiv+2)
 tic_lab(0)=string(fix(xtic(0)))
 tic_lab(ndiv+1)=string(fix(xtic(ndiv)+0.51))
 for k = 1, ndiv do begin
  tic_lab(k)=string(fix( (xtic(k-1)+xtic(k))/2. +0.001))
 endfor
endif
if igraph eq -56 then begin
  ndiv = 18
  inoveg = 0  
  xtic  = [0,0.5,1,1.5,2,2.5,3,3.5,4,4.5,5,5.5,6,6.5,7,7.5,8,9,10]    ;yield
  midtic = ' - '
  lowtic = '  '
  hightic = ' > '
  formtic = 'f4.1'  
endif
if igraph eq -55 then begin
 if ianom eq 0 then begin
  ndiv = 18
  inoveg = 0  
  kgrey = 1
  xtic  = [0.00000,0.00002,0.00005,0.0001,0.0002,0.0005,0.001,0.002,0.005,0.01,0.02,0.05,0.1,0.2,0.5,1,2,5,10]    ;Carb Weath
  midtic = ' - '
  lowtic = '  '
  hightic = ' > '
  formtic = 'f8.5'  
 endif 
 if ianom eq 1 then begin
  ndiv = 18
  inoveg = 0  
  kgrey = 10
  xtic  = [-0.2,-0.1,-0.05,-0.02,-0.01,-0.005,-0.002,-0.001,-0.0005,0.0005,0.001,0.002,0.005,0.01,0.02,0.05,0.1,0.2,0.5]    ;Carb Weath
  midtic = ' - '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'f8.5' 
 endif
 if ianom eq 2 then begin
  ndiv = 18
  inoveg = 0  
  kgrey = 10
  xtic  = [0.01,0.02,0.05,0.1,0.2,0.5,0.7,0.8,0.9,1,1.1,1.2,1.3,1.4,1.5,2,3,4,5]    ;Carb Weath
  midtic = ' - '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'f8.5' 
 endif 
endif
if igraph eq -54 then begin
 if ianom eq 0 then begin
  ndiv = 18
  inoveg = 0  
  xtic  = [300,400,500,600,700,800,1000,1200,1400,1600,1800,2000,2500,3000,4000,5000,6000,8000,10000]    ;Soil PCO2
  midtic = ' - '
  lowtic = '  '
  hightic = ' > '
  formtic = 'i5' 
 endif else begin
  ndiv = 19
  inoveg = 0
  xtic  = [-800,-600,-400,-300,-200,-100,0,100,200,300,400,600,800,1000,1500,2000,2500,3000,4000,5000]   ;tem
  midtic = ' to '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'i6' 
  dircol = 1  
 endelse 
endif
if igraph eq -53 then begin
 if ianom eq 0 then begin
  ndiv = 18
  inoveg = 0  
  xtic  = [-14,-12,-10,-9,-8,-7,-6,-5,-4,-3,-2,-1,0,2,4,6,8,10,12]    ;Lapse rate
  midtic = ' to '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'i5' 
 endif else begin
  ndiv = 18
  inoveg = 0
  xtic  = 0.5*[-14,-12,-10,-9,-8,-7,-6,-5,-4,-3,-2,-1,0,2,4,6,8,10,12]   ;Lapse rate anomaly
  midtic = ' to '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'i5'  
 endelse 
endif
if igraph eq -52 then begin
 if ianom eq 0 then begin
;  ndiv = 18
  inoveg = 0  
;  xtic  = [0,0.1,0.2,0.5,1.,1.5,2.,3.,4.,5.,6.,8.,10.,12.,14.,16.,18,20.,25.,30.]    ;Specific humidity
  xtic  = [0.1,0.2,0.5,1.,1.5,2.,2.5,3.,3.5,4.,4.5,5.,6.,7.,8.,9.,10.,11.,12.,14.,16.]    ;Specific humidity  
  sxt = size(xtic)
  ndiv = sxt(1)-1
  midtic = ' to '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'f5.1' 
 endif else begin
  ndiv = 18
  inoveg = 0
  xtic  = 0.5*[-14,-12,-10,-9,-8,-7,-6,-5,-4,-3,-2,-1,0,2,4,6,8,10,12]   ;Lapse rate anomaly
  midtic = ' to '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'i5'  
 endelse 
endif
if (igraph eq -41) then begin
 if ianom eq 0 then begin
  ndiv = 17
  inoveg = 0  
  xtic  = [0,20,50,100,200,500,1000,1500,2000,3000,4000,6000,8000,10000,15000,20000,25000,30000]    ;biommth
  xtic  = [0,500,1000,1500,2000,2500,3000,3500,4000,4500,5000,5500,6000,6500,7000,7500,8000,8500,9000,9500,10000,10500,11000]
 
  midtic = ' - '
  lowtic = '  '
  hightic = ' > '
  formtic = 'i6' 
 endif else begin
    inoveg = 0
;    ndiv = 15
;    xtic  = [-2000,-1500-1000,-600,-400,-200,-100,-50,50,200,500,1000,2000,5000] ;anom biommth
   xtic = [-3000,-2000,-1500,-1000,-800,-600,-500,-400,-300,-200,-100,-0.4,0.4,100,200,300,400,500,600,800,1000,1500,2000,3000]  ;LU fraction difference  
   midtic = ' : '
   lowtic = ' < '
   hightic = ' > '
   formtic = 'i6' 
   dircol = 1 
   zerogrey = 1
   zerocol = 13
   zeroleg = ' 0 '
 endelse 
endif
if (igraph eq -40) then begin
  inoveg = 0
  ndiv = 20
   xtic  = [-200,-180,-160,-140,-120,-100,-80,-60,-40,-20,0,20,40,60,80,100,120,140,160,180,200]  ;rn W m-2 
  midtic = ' - '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'i6' 
  dircol = 1 
endif

if (igraph eq -39) then begin
 if ianom eq 0 then begin
  inoveg = 0
;  ndiv = 20
;   xtic  = [0,20,40,60,80,100,120,140,160,180,200,250,300,350,400,500,600,700,800,900,1000]  ;fsol W m-2
  xtic  = [0,20,40,60,80,100,120,140,160,180,200,220,240,260,280,300,320,340,360,380,400]  ;fsol W m-2
;  xtic  = [0,10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,170,180,190,200]  ;fsol W m-2
;  xtic  = [0,5,10,15,20,25,30,35,40,45,50,55,60,65,70,75,80,85,90,95,100]  ;fsol W m-2  
  sxt = size(xtic)
  ndiv = sxt(1)-1   
  midtic = ' - '
  lowtic = '   '
  hightic = ' > '
  formtic = 'i6' 
  dircol = 1 
 endif else begin
  ndiv = 19
  inoveg = 0
   xtic  = 20.*[-5.,-4.5,-3.0,-3.5,-3.0,-2.5,-2.0,-1.5,-1,-0.5,0,0.5,1,1.5,2,2.5,3,3.5,4,4.5,5]  ;dfsol
  midtic = ' - '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'f7.1' 
  dircol = 1    
 endelse  
  
endif
if (igraph eq -38) then begin
  inoveg = 0
  ndiv = 20
   xtic  = 0.10*[0,100,200,300,400,600,800,1000,1200,1400,1600,1800,2000,2500,3000,4000,5000,10000,20000,50000,100000] ;snd
  midtic = ' - '
  lowtic = '   '
  hightic = ' > '
  formtic = 'i6' 
  dircol = 1 
endif
if (igraph eq -36) or (igraph eq -37) then begin
 if ianom eq 0 then begin 
  ndiv = 19
  inoveg = 0
  xtic  = [-25,-20,-15,-10,-5,0,5,10,15,20,25,30,35,40,45,50,60,70,80,90]   ;xh, xle
  midtic = ' to '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'i4' 
  dircol = 1 
 endif else begin
  ndiv = 19
  inoveg = 0
;  xtic  = [-3.0,-2.5,-2.0,-1.5,-1,-0.5,0,0.5,1,1.5,2,2.5,3,3.5,4,4.5,5,6,7,8]   ;xh
   xtic  = [-3.0,-2.5,-2.0,-1.5,-1,-0.5,0,0.5,1,1.5,2,2.5,3,3.5,4,4.5,5,6,7,8]  ;xh
  midtic = ' - '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'f6.2' 
  dircol = 1    
 endelse
endif
if (igraph eq -35) then begin
 if ianom eq 0 then begin 
  ndiv = 19
  inoveg = 0
;  xtic  = [-55,-50,-45,-40,-35,-30,-25,-20,-15,-10,-5,0,5,10,15,20,25,30,35]   ;ts
  xtic  = [0,2,4,6,8,10,12,14,16,18,20,22,24,26,28,30,32,34,36,38]   ;ts 
;  xtic  = [-16,-14,-12,-10,-8,-6,-4,-2,0,2,4,6,8,10,12,14,16,18,20]   ;ts
;  xtic  = [-20,-15,-10,-5,-2,0,2,4,6,8,10,12,14,16,18,20,22,24,26]   ;tsmin
; xtic  = [-10,-5,0,2,4,6,8,10,12,14,16,18,20,22,24,26,28,30,32,34]   ;ts
  midtic = ' to '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'i4' 
  dircol = 1 
 endif else begin
  ndiv = 19
  inoveg = 0
;  xtic  = [-3.0,-2.5,-2.0,-1.5,-1,-0.5,0,0.5,1,1.5,2,2.5,3,3.5,4,4.5,5,6,7,8]   ;ts
   xtic  = [-3.0,-2.5,-2.0,-1.5,-1,-0.5,0,0.5,1,1.5,2,2.5,3,3.5,4,4.5,5,6,7,8]  ;ts
  midtic = ' - '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'f6.2' 
  dircol = 1    
 endelse
endif
if (igraph eq -34) then begin
 if ianom eq 0 then begin
  ndiv = 18
  inoveg = 0 
  xtic = [0.01,0.02,0.04,0.06,0.08,0.1,0.15,0.2,0.25,0.3,0.4,0.5,0.6,0.7,0.8,1.0,1.2,1.4,1.6]  ;SW
  if imonth eq -3 then xtic = [0.01,0.02,0.03,0.04,0.05,0.06,0.08,0.1,0.12,0.14,0.16,0.18,0.2,0.25,0.3,0.35,0.4,0.6,0.8]  ;SW
  midtic = ' - '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'f6.2' 
  dircol = -1
 endif 
 if ianom eq 1 then begin
  ndiv = 19
  inoveg = 0 
  xtic = [-0.40,-0.30,-0.25,-0.20,-0.15,-0.10,-0.08,-0.06,-0.04,-0.02,0.02,0.04,0.06,0.08,0.10,0.15,0.20,0.25,0.30,0.40]  ;SW
  midtic = ' to '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'f6.2' 
  dircol = -1
 endif
 if ianom eq 2 then begin
  ndiv = 20
  inoveg = 0
  xtic = [-40,-30,-25,-20,-15,-10,-8,-6,-4,-2,0,2,4,6,8,10,15,20,25,30,40]  ;SW   
  midtic = ' to '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'i4' 
  dircol = -1
 endif
endif
if (igraph eq -33) then begin
 if ianom eq 0 then begin
  ndiv = 18
  inoveg = 0
  xtic  = [0,2,5,10,15,20,30,40,50,60,80,100,120,140,160,180,200,250,300]   ;run mth
  midtic = ' - '
  lowtic = '   '
  hightic = ' > '
  formtic = 'i4' 
  dircol = -1 
  if imonth eq -1 then begin
    ndiv = 16
    xtic  = [5,10,25,50,75,100,150,200,250,300,400,600,800,1000,1500,2000,5000] ;run annual UNESCO
;    ndiv = 19
;    xtic  = [0,25,50,75,100,125,150,175,200,250,300,350,400,450,500,600,700,800,900,1000]  ;run annual
    lowtic = ' < '
  endif
  if (imonth le -13) and (imonth ge -17) then begin
    ndiv = 18
    xtic  = [0,2,5,10,20,30,40,60,80,100,150,200,300,400,500,600,800,900,1000]   ;aet seasonal
    lowtic = '  '
  endif  
 endif else begin
  ndiv = 18
  inoveg = 0
  xtic  = [-100,-80,-60,-40,-30,-20,-10,-5,-2,0,2,5,10,20,30,40,60,80,100]   ;aet 
  midtic = ' to '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'i4' 
  dircol = -1 
  if imonth eq -1 then begin
    ndiv = 20
    xtic  = [-800,-700,-600,-500,-400,-300,-200,-100,-50,-20,0,20,50,100,200,300,400,500,600,700,800];aet annual
  endif
  if (imonth le -13) and (imonth ge -17) then begin
    ndiv = 18
    xtic  = [-1000,-800,-600,-400,-300,-200,-100,-50,-20,0,20,50,100,200,300,400,600,800,1000]   ;aet seasonal
  endif
 endelse
endif
if (igraph eq -31) or (igraph eq -32) then begin
 if ianom eq 0 then begin
  ndiv = 18
  inoveg = 0
 ; xtic  = [0,2,5,10,15,20,30,40,50,60,80,100,120,140,160,180,200,250,300]   ;aet
  xtic  = [0,2,5,10,15,20,25,30,35,40,45,50,60,70,80,90,100,110,120]   ;aet, pet
  midtic = ' - '
  lowtic = '  '
  hightic = ' > '
  formtic = 'i4' 
  dircol = -1 
  if imonth eq -1 then begin
    ndiv = 18
   ; xtic  = [0,10,20,50,100,150,200,250,300,400,500,600,800,1000,1500,2000,2500,3000,5000] ;aet annual
    ndiv = 19
    xtic  = [0,25,50,75,100,125,150,175,200,250,300,350,400,450,500,600,700,800,900,1000]
    lowtic = '  '
  endif
  if (imonth le -13) and (imonth ge -17) then begin
    ndiv = 18
    xtic  = [0,2,5,10,20,30,40,60,80,100,150,200,300,400,500,600,800,900,1000]   ;aet seasonal
    lowtic = '  '
  endif  
 endif else begin
  ndiv = 18
  inoveg = 0
  xtic  = [-100,-80,-60,-40,-30,-20,-10,-5,-2,0,2,5,10,20,30,40,60,80,100]   ;aet 
  midtic = ' to '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'i4' 
  dircol = -1 
  if imonth eq -1 then begin
    ndiv = 20
    xtic  = [-800,-700,-600,-500,-400,-300,-200,-100,-50,-20,0,20,50,100,200,300,400,500,600,700,800];aet annual
  endif
  if (imonth le -13) and (imonth ge -17) then begin
    ndiv = 18
    xtic  = [-1000,-800,-600,-400,-300,-200,-100,-50,-20,0,20,50,100,200,300,400,600,800,1000]   ;aet seasonal
  endif
 endelse
endif
if (igraph eq -30) then begin
  ndiv = 18
  inoveg = 0
;  xtic  = [0.05,0.10,0.15,0.20,0.25,0.30,0.35,0.40,0.45,0.50,0.55,0.60,0.65,0.70,0.75,0.80,0.85,0.90,0.95]   ;alb 
  xtic  = [0.10,0.12,0.14,0.16,0.18,0.20,0.22,0.24,0.26,0.28,0.30,0.32,0.34,0.36,0.38,0.40,0.50,0.60,0.70]   ;alb
  midtic = ' - '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'f4.2' 
  dircol = 1 
endif
if (igraph eq -29) then begin
  ndiv = 18
  inoveg = 0
  xtic  = [0.5,1,1.5,2,2.5,3,4,5,6,7,8,9,10,12,16,18,20,25,30]   ;wnd 
  midtic = ' - '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'f4.1' 
  dircol = 1 
endif
if (igraph eq -28) then begin
 if ianom eq 0 then begin
  ;ndiv = 18
  inoveg = 0
;  xtic  = [5,10,15,20,25,30,35,40,45,50,55,60,65,70,75,80,85,90,95]   ;shr ;rhu
  xtic  = [10,20,30,40,50,60,70,72,74,76,78,80,82,84,86,88,90,92,94,96,98]   ;shr ;rhu
  midtic = ' - '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'i4'  
  dircol=-1
 endif else begin
  ;ndiv = 18
  inoveg = 0
  xtic  = [-50,-40,-30,-20,-15,-10,-8,-6,-4,-2,0,2,4,6,8,10,15,20,30,40,50]   ;shr ;rhu
  midtic = ' - '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'i4' 
  dircol = 1 
 endelse  
endif
if (igraph eq -27) then begin
 if ianom eq 0 then begin
  ndiv = 18
  inoveg = 0
  xtic  = [5,10,15,20,25,30,35,40,45,50,55,60,65,70,75,80,85,90,95]   ;shr ;rhu
;  xtic  = [10,20,22,24,26,28,30,32,34,36,38,40,42,44,46,48,50,60,70,80,90]   ;shr ;rhu
  midtic = ' - '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'i4' 
  dircol = 1 
 endif else begin
  ndiv = 18
  inoveg = 0
  xtic  = [-45,-40,-35,-30,-25,-20,-15,-10,-5,0,5,10,15,20,25,30,35,40,45]   ;shr ;rhu
  midtic = ' - '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'i4' 
  dircol = 1 
 endelse  
endif
if (igraph eq -26) then begin
 if ianom eq 0 then begin
  ndiv = 18
  inoveg = 0
  xtic  = [0,5,10,15,20,25,30,35,40,45,50,55,60,65,70,75,80,90,100,120,150]   ;prc  
;  xtic  = [0,2,5,10,15,20,30,40,50,60,80,100,120,150,200,250,300,400,500]   ;prc 
;  xtic  = [0,2,5,10,15,20,30,40,50,60,70,80,90,100,110,120,130,140,150]   ;prc 
  if imonth eq -1 then xtic  = [0,50,100,150,200,250,300,350,400,450,500,600,700,800,900,1000,1200,1400,1600] ;prc annual
;  if imonth eq -1 then xtic  = [0,10,20,50,100,150,200,250,300,400,500,600,800,1000,1500,2000,2500,3000,5000]
;  if imonth eq -1 then xtic  = [0,200,400,600,800,1000,1200,1400,1600,1800,2000,2200,2400,2600,2800,3000,3200,3400,3600]
;  if imonth eq -1 then xtic  = [0,100,200,300,400,500,600,700,800,900,1000,1100,1200,1300,1400,1500,1600,1800,2000]
  if (imonth le -13) and (imonth ge -17) then xtic  = [0,2,5,10,20,30,40,60,80,100,150,200,300,400,500,600,800,900,1000]   ;prc seasonal
  midtic = ' - '
  lowtic = '  '
  hightic = ' > '
  formtic = 'i4' 
  dircol = -1 
 endif else begin
   ndiv = 18
  inoveg = 0
  xtic  = [-100,-80,-60,-40,-30,-20,-10,-5,-2,0,2,5,10,20,30,40,60,80,100]   ;prc 
;  if imonth eq -1 then xtic  = [-375,-325,-275,-225,-200,-100,0,100,200,225,275,325,375,425,475,525,575,625,675] ;prc annual
  if imonth eq -1 then xtic  = [-300,-250,-200,-150,-100,-50,-20,-10,-5,-2,0,2,5,10,20,50,100,150,200,250,300] ;prc annual  
;  if (imonth le -13) and (imonth ge -17) then xtic  = [-100,-80,-60,-40,-30,-20,-10,-5,-2,0,2,5,10,20,30,40,60,80,100]   ;prc seasonal
  if (imonth le -13) and (imonth ge -17) then xtic  = [-225,-195,-165,-135,-105,-75,-45,-15,15,45,75,105,135,165,195,225,255,285,315]   ;prc seasonal  
  midtic = ' - '
  lowtic = '  '
  hightic = ' > '
  formtic = 'i4' 
  dircol = -1 
 endelse
endif
if (igraph eq -25) then begin
 if ianom eq 0 then begin
  ndiv = 18
  inoveg = 0
  xtic  = [1,2,3,4,5,6,7,8,9,10,12,14,16,18,20,22,24,26,28]   ;tem  
  midtic = ' - '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'i4' 
  dircol = 1 
 endif else begin
  ndiv = 19
  inoveg = 0
;  xtic  = [-3.0,-2.5,-2.0,-1.5,-1,-0.5,0,0.5,1,1.5,2,2.5,3,3.5,4,4.5,5,6,7,8]   ;tem
;   xtic  = [-3.0,-2.5,-2.0,-1.5,-1,-0.5,0,0.5,1,1.5,2,2.5,3,3.5,4,4.5,5,6,7,8]  ;tem
 ;     xtic  = [1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75,4,4.25,4.5,4.75,5,5.25,5.5,5.75,6,6.25]  ;tem
  xtic  = [-3,0,-2.5,-2.0,-1.75,-1.5,-1.25,-1,-0.75,-0.5,-0.25,0,0.25,0.5,0.75,1,1.25,1.5,1.75,2,2.5,3]   ;tem    
  midtic = ' - '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'f6.2' 
  dircol = 1    
 endelse  
endif
if (igraph eq -24) then begin
 if ianom eq 0 then begin 
;  ndiv = 19
  inoveg = 0
;  xtic  = [-55,-50,-45,-40,-35,-30,-25,-20,-15,-10,-5,0,5,10,15,20,25,30,35]   ;tem
;  xtic  = [2,4,6,8,10,12,14,16,18,20,22,24,26,28,30,32,34,36,38,40]   ;tem 

;  xtic  = [3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22]   ;tem
;  xtic  = [-25,-20,-15,-10,-5,-2,0,2,4,6,8,10,12,14,16,18,20,22,24,26]   ;temmin
 xtic  = [-10,-5,0,2,4,6,8,10,12,14,16,18,20,22,24,26,28,30,32,34]   ;tem
;  xtic  = [-1,0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21]   ;tem
  sxt = size(xtic)
  ndiv = sxt(1)-1

  midtic = ' - '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'i4' 
  dircol = 1 
 endif else begin
  ndiv = 19
  inoveg = 0
;  xtic  = [-3.0,-2.5,-2.0,-1.5,-1,-0.5,0,0.5,1,1.5,2,2.5,3,3.5,4,4.5,5,6,7,8]   ;tem
;   xtic  = [-3.0,-2.5,-2.0,-1.5,-1,-0.5,0,0.5,1,1.5,2,2.5,3,3.5,4,4.5,5,6,7,8]  ;tem
 ;     xtic  = [1.5,1.75,2,2.25,2.5,2.75,3,3.25,3.5,3.75,4,4.25,4.5,4.75,5,5.25,5.5,5.75,6,6.25]  ;tem
  xtic  = [-3,0,-2.5,-2.0,-1.75,-1.5,-1.25,-1,-0.75,-0.5,-0.25,0,0.25,0.5,0.75,1,1.25,1.5,1.75,2,2.5,3]   ;tem    
  midtic = ' - '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'f6.2' 
  dircol = 1    
 endelse
endif
if (igraph eq -23) then begin
  ndiv = 19
  inoveg = 0
;  xtic  = [-15,-10,-5,0,2,4,6,8,10,12,14,15,16,17,18,19,20,21,22,24]   ;tmin
;  xtic  = [-65,-60,-55,-50,-45,-40,-35,-30,-25,-20,-15,-10,-5,0,5,10,15,20,25,30]   ;tmin 
  xtic  = [-25,-20,-15,-10,-5,-2,0,2,4,6,8,10,12,14,16,18,20,22,24,26]   ;temmin 
  if (imonth eq 2) or (imonth eq 4) or (imonth eq 6) then xtic  = [-35,-30,-25,-20,-15,-10,-5,0,5,10,15,20,25,30,35,40,45,50,55]   ;tmax
  midtic = ' to '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'i4' 
  dircol = 1 
endif
if (igraph eq -22) then begin
  ndiv = 15
  inoveg = 0
  xtic  = [500,1000,1500,2000,2500,3000,3500,4000,4500,5000,5500,6000,6500,7000,7500,8000]   ;gdd
  midtic = ' - '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'i4' 
  dircol = 1 
endif
if (igraph eq -21) then begin
  inoveg = 0
  ndiv = 19
  ; xtic  = [-50,-20,0,50,100,200,300,400,600,800,1000,1200,1400,1600,1800,2000,2500,3000,4000,5000]
;   xtic  = [-50,-20,0,100,200,300,400,500,600,700,800,900,1000,1100,1200,1300,1400,1600,1800,2000]
;   xtic=xtic*0.5
;   xtic  = [-50,-20,0,200,400,600,800,1000,1200,1400,1600,1800,2000,2200,2400,2600,2800,3000,3200]
   xtic  = [-50,-20,0,400,500,600,700,800,900,1000,1100,1200,1300,1400,1600,1800,2000,2200,2400,2600]   
  ;ndiv = 19 
  xtic  = [-20,-10,0,2,10,20,50,75,100,150,200,250,300,350,400,450,500,550,600,650]   ;elev
  midtic = ' - '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'i4' 
  dircol = 1 
endif
if (igraph eq -20) then begin
;  ndiv = 15
  inoveg = 0 
  xtic = [-200,-180,-160,-140,-120,-100,-80,-60,-40,-20,-10,-5,5,10,20,40,60,80,100,120,140,160,180,200]  ;NBPmth
;  if imonth eq -1 then xtic = [0,50,100,150,200,250,300,400,500,600,700,800,900,1000,1200]    ;nbpyr
;  if (imonth le -13) and (imonth ge -17) then xtic  = [0,5,10,15,20,40,60,80,100,150,200,250,300,400,500]   ;nbp seasonal
  midtic = ' - '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'i5'
endif
if (igraph eq -19) then begin
 if ianom eq 0 then begin
  ndiv = 14
  inoveg = 0 
  xtic = [0,5,10,15,20,30,40,50,60,80,100,120,140,160,180]  ;Ramth
  if imonth eq -1 then xtic = [0,50,100,150,200,250,300,400,500,600,700,800,900,1000,1200]    ;Rayr
  if (imonth le -13) and (imonth ge -17) then xtic  = [0,5,10,15,20,40,60,80,100,150,200,250,300,400,500]   ;Ra seasonal
  midtic = ' - '
  lowtic = '  '
  hightic = ' > '
  formtic = 'i5'
 endif else begin
  ndiv = 18
  inoveg = 0 
  xtic = [-100,-80,-60,-40,-30,-20,-15,-10,-5,0,5,10,15,20,30,40,60,80,100]  ;Ramth
  if imonth eq -1 then xtic =  [-400,-300,-200,-150,-100,-50,-20,-10,-5,0,5,10,20,50,100,150,200,300,400]   ;Rayr
  if (imonth le -13) and (imonth ge -17) then xtic  = [-200,-150,-100,-80,-60,-40,-20,-10,-5,0,5,10,20,40,60,80,100,150,200]   ;Ra seasonal
  midtic = ' to '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'i5' 
 endelse  
endif
if (igraph eq -18) then begin
;  ndiv = 15
  inoveg = 0 
;  xtic = [-200,-150,-100,-80,-60,-40,-20,-5,5,20,40,60,80,100,150,200]  ;NEPmth
  xtic = [-200,-180,-160,-140,-120,-100,-80,-60,-40,-20,-10,-5,5,10,20,40,60,80,100,120,140,160,180,200]  ;NEPmth  
;  if imonth eq -1 then xtic = [0,50,100,150,200,250,300,400,500,600,700,800,900,1000,1200]    ;nepyr
;  if (imonth le -13) and (imonth ge -17) then xtic  = [0,5,10,15,20,40,60,80,100,150,200,250,300,400,500]   ;nep seasonal
  midtic = ' - '
  lowtic = '  '
  hightic = ' > '
  formtic = 'i5'
endif
if (igraph eq -17) then begin
 if ianom eq 0 then begin
  ndiv = 14
  inoveg = 0 
  xtic = [0,5,10,15,20,30,40,50,60,80,100,120,140,160,180,200,250,300,400]  ;GPPmth
  ;if imonth eq -1 then xtic =[0,50,100,150,200,250,300,400,500,600,800,1000,1200,1400,1600,1800,2000,2500,3000]    ;gppyr
  if imonth eq -1 then xtic =[25,250,500,750,1000,1250,1500,1750,2000,2250,2500,2750,3000,3250,3500]    ;gppyr
  if (imonth le -13) and (imonth ge -17) then xtic  = [0,5,10,15,20,40,60,80,100,150,200,250,300,400,500,600,800,1000,1200]   ;gpp seasonal
  midtic = ' - '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'i5' 
 endif else begin
  ndiv = 18
  inoveg = 0 
  xtic = [-100,-80,-60,-40,-30,-20,-15,-10,-5,0,5,10,15,20,30,40,60,80,100]  ;NPPmth
  if imonth eq -1 then xtic =  [-400,-300,-200,-150,-100,-50,-20,-10,-5,0,5,10,20,50,100,150,200,300,400]   ;nppyr
  if (imonth le -13) and (imonth ge -17) then xtic  = [-200,-150,-100,-80,-60,-40,-20,-10,-5,0,5,10,20,40,60,80,100,150,200]   ;npp seasonal
  midtic = ' to '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'i5' 
 endelse  
endif
if (igraph eq -16) then begin
 if ianom eq 0 then begin
  ndiv = 16
  inoveg = 0 
  xtic = [-40,-30,-20,-10,0,10,20,30,40,50,60,80,100,120,140]  ;NPPmth
  if imonth eq -1 then xtic = [0,10,20,50,100,150,200,250,300,400,500,600,700,800,900]    ;nppyr
;  if imonth eq -1 then xtic = [460,480,500,520,540,560,580,600,620,640,660,680,700,720,740]    ;nppyr  
  if (imonth le -13) and (imonth ge -17) then xtic  = [-60,-40,-20,-10,0,10,20,40,60,80,100,150,200,250,300]   ;npp seasonal
  midtic = ' - '
  if imonth eq -1 then lowtic = ' < ' else lowtic = ' < '
  hightic = ' > '
  formtic = 'i5'
 endif else begin
  ndiv = 18
  inoveg = 0 
  xtic = [-100,-80,-60,-40,-30,-20,-15,-10,-5,0,5,10,15,20,30,40,60,80,100]  ;NPPmth
  if imonth eq -1 then xtic =  [-400,-300,-200,-150,-100,-50,-20,-10,-5,0,5,10,20,50,100,150,200,300,400]   ;nppyr
  if (imonth le -13) and (imonth ge -17) then xtic  = [-200,-150,-100,-80,-60,-40,-20,-10,-5,0,5,10,20,40,60,80,100,150,200]   ;npp seasonal
  midtic = ' to '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'i5' 
 endelse  
endif
if (igraph eq -15) then begin
 if ianom eq 0 then begin
  ndiv = 14
  inoveg = 1  
  xtic = [-10,0.01,0.1,0.2,0.3,0.5,1.,1.5,2.,2.5,3.,4.,5.,6.,7.]  ;LAI
  midtic = ' - '
  lowtic = ' '
  hightic = ' > '
  formtic = 'f3.1' 
 endif else begin 
  ndiv = 15
  inoveg = 1  
  xtic = [-4,-3,-2,-1.5,-1.,-0.6,-0.3,-0.1,0.1,0.3,0.6,1.,1.5,2.,3.,4.]  ;LAI
  midtic = ' - '
  lowtic = ' '
  hightic = ' > '
  formtic = 'f4.1' 
 endelse 
endif
if (igraph eq -14) then begin
  ndiv = 16
  inoveg = 0  
  xtic  = [0,0.001,0.002,0.005,0.01,0.02,0.05,0.1,0.2,0.5,1,2,5,10,20,50,100]    ;pcburn
  midtic = ' - '
  lowtic = '  '
  hightic = '  '
  formtic = 'f7.3' 
endif
if (igraph eq -13) then begin
  ndiv = 16
  inoveg = 0  
  xtic  = [0,0.02,0.05,0.1,0.2,0.5,1,2,10,20,50,100,200,500,1000,2000,5000]    ;aburn
  midtic = ' - '
  lowtic = '  '
  hightic = ' > '
  formtic = 'f8.2' 
endif
if (igraph eq -12) then begin
  ndiv = 13
  inoveg = 0  
  xtic  = [0,0.0001,0.0002,0.0005,0.001,0.002,0.005,0.01,0.02,0.05,0.1,0.2,0.5,1]    ;pfire
  midtic = ' - '
  lowtic = '  '
  hightic = '  '
  formtic = 'f6.4' 
endif
if (igraph eq -11) then begin
  ndiv = 14
  inoveg = 0  
  xtic  = [60,80,100,150,200,300,400,600,800,1000,1500,2000,3000,4000,6000]    ;taufire
  midtic = ' - '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'i5'
  dircol = -1  
endif
if (igraph eq -10) then begin
  ndiv = 14
  inoveg = 0  
  xtic  = [0,20,50,100,150,200,250,300,350,400,450,500,600,700,800]    ;npppft
  midtic = ' - '
  lowtic = '  '
  hightic = ' > '
  formtic = 'i4'  
endif
if (igraph eq -8) or (igraph eq -9) then begin
 if ianom eq 0 then begin
;  ndiv = 17
  inoveg = 0  
;  xtic  = [0,0.02,0.05,0.1,0.2,0.5,1,1.5,2,3,4,6,8,10,15,20,25,30]    ;Cveg  Csoil  Ctot
  xtic  = [0,0.05,0.1,0.2,0.5,1,2,4,6,8,10,12,14,16,18,20,25,30,35,40]    ;Cveg  Csoil  Ctot
   xtic  = [0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16]    ;Cveg  Csoil  Cto  
  midtic = ' - '
  lowtic = '  '
  hightic = ' > '
  formtic = 'f6.2' 
 endif else begin
    inoveg = 0
    ndiv = 15
    xtic  = [-20,-15,-10,-5,-2,-1,-0.5,-0.2,0.2,0.5,1,2,5,10,15,20] ;anom Csoil
    midtic = ' to '
    lowtic = ' < '
    hightic = ' > '
    formtic = 'f5.1'  
 endelse 
endif

if (igraph eq -7) then begin
  ndiv = 17
  inoveg = 0  
  xtic  = [0,0.1,0.2,0.5,1,2.5,5,7.5,10,12.5,15,17.5,20,25,30,35,40,50]    ;Cveg  Csoil  Ctot
  midtic = ' - '
  lowtic = '  '
  hightic = ' > '
  formtic = 'f4.1'  
endif

if igraph eq -6 then begin
  ndiv = 14
  inoveg = 1
  xtic  = [-100,-28,-27,-26,-25,-24,-23,-22,-20,-18,-16,-15,-14,-13,-12]    ;d13C
  midtic = ' to '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'i4'   
endif

if igraph eq -5 then begin
  ndiv = nbiome-2
  inoveg = 0  
  xtic  = [1.5,2.5,3.5,4.5,5.5,6.5,7.5,8.5,9.5,10.5,11.5,12.5,13.5,14.5,15.5,16.5,17.5,18.5,19.5,20.5,21.5,22.5,23.5]  ;Biomes
  midtic = ' - '
  lowtic = '  '
  hightic = ' > '
  formtic = 'i4'   
  iclass = 1
  jplalldiv = 0
  ibw=0
endif

if (igraph eq -3) or (igraph eq -4) then begin
  ndiv = 14
  inoveg = 1  
  xtic = [-10,0.01,0.1,0.2,0.3,0.5,1.,1.5,2.,2.5,3.,4.,5.,6.,7.]  ;LAI
  midtic = ' - '
  lowtic = ' '
  hightic = ' > '
  formtic = 'f3.1'  
endif
if igraph eq -2 then begin
  ndiv = 11
  inoveg = 1  
  xtic = [-10,0.01,10,20,30,40,50,60,70,80,90,100]  ;cnpptree
  midtic = ' - '
  lowtic = ' '
  hightic = ' '
  formtic = 'i4'  
endif
if igraph eq -1 then begin
  ndiv = nbag
  inoveg = 0  
  xtic= fltarr(ndiv+1)
  for k=0,ndiv do xtic(k)  = -0.5+k*1.    ;Dom pft
  midtic = ' - '
  lowtic = '  '
  hightic = ' > '
  formtic = 'i4'   
  iclass = 1
  jplalldiv = 1
endif
if igraph eq 0 then begin
 if ianom eq 0 then begin
  ndiv = 16
  inoveg = 0  
  xtic  = [0,10,20,50,100,150,200,250,300,400,500,600,700,800,900,1000,1200]    ;npp
  midtic = ' - '
  lowtic = '  '
  hightic = ' > '
  formtic = 'i4' 
 endif else begin
    inoveg = 0
    ndiv = 15
    xtic  = [-600,-500,-400,-300,-200,-100,-50,-20,20,50,100,200,300,400,500,600] ;anom npp annual
    midtic = ' to '
    lowtic = ' < '
    hightic = ' > '
    formtic = 'i5'   
 endelse 
endif
if (igraph ge 1) and (igraph le nplant) then begin
 if ianom eq 0 then begin
  ndiv = 14
  inoveg = 0  
  xtic  = [0,50,100,150,200,250,300,400,500,600,700,800,900,1000,1200]    ;npppft
;  xtic  = [0,50,100,150,200,250,300,350,400,450,500,600,700,800,900]    ;npppft  
  midtic = ' - '
  lowtic = '  '
  hightic = ' > '
  formtic = 'i4'
  ibw=0  
 endif else begin
  ndiv = 18
  inoveg = 0  
  xtic  = [-1000,-800,-600,-400,-300,-200,-150,-100,-50,0,50,100,150,200,300,400,600,800,1000]    ;npppft
  midtic = ' to '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'i5'
  ibw=0 
 endelse
endif
if (igraph ge nplant+1) and (igraph le 2*nplant) then begin
  ndiv = 15
  inoveg = 0  
  xtic = [0.00,0.001,0.002,0.005,0.01,0.02,0.05,0.10,0.15,0.20,0.25,0.30,0.40,0.60,0.8,1.0]  ;frac
  midtic = ' - '
  lowtic = ' '
  hightic = ' '
  formtic = 'f5.3'  
endif
if(igraph ge 2*nplant+1) and (igraph le 3*nplant) then begin
  ndiv = 17
  inoveg = 0  
  xtic = [0.0049,0.05,0.1,0.2,0.5,1.0,1.5,2.0,2.5,3,4,5,10,15,20,25,30,40]  ;cnpp
  midtic = ' - '
  lowtic = ' '
  hightic = ' > '
  formtic = 'f5.2'  
endif
if(igraph ge 3*nplant+1) and (igraph le 4*nplant) then begin
  ndiv = 17
  inoveg = 0  
  xtic  = [0,1,2,5,10,25,50,75,100,150,200,250,300,400,500,600,800,1000]    ;fnpp
  midtic = ' - '
  lowtic = '  '
  hightic = ' > '
  formtic = 'i4'  
endif
if(igraph ge 4*nplant+1) and (igraph le 5*nplant) then begin
  ndiv = 14
  inoveg=1  
  xtic = [-100,0.01,3,4,5,13,14,15,16,17,18,19,20,21,22]  ;frc13
  midtic = ' - '
  lowtic = '  '
  hightic = ' > '
  formtic = 'i4'  
endif
if(igraph ge 5*nplant+1) and (igraph le 6*nplant) then begin
  ndiv = 0
  inoveg=1  
  xtic = [100]  ;npp
  xtic(0)=anppthres
  midtic = ' - '
  lowtic = '  '
  hightic = ' > '
  formtic = 'i4'
  iclass = 1  
endif
if(igraph ge 6*nplant+1) and (igraph le 7*nplant) then begin
 if ianom eq 0 then begin
  ndiv = 17
  inoveg = 0 
  xtic  = [0.001,0.02,0.05,0.1,0.2,0.5,1,1.5,2,3,4,6,8,10,15,20,25,30]    ;biompft
  midtic = ' - '
  lowtic = '  '
  hightic = ' > '
  formtic = 'f6.2'
  ibw=0  
 endif else begin
  ndiv = 14
  inoveg = 0  
  xtic  = [-20,-10,-5,-2,-1,-0.5,-0.1,0,0.1,0.5,1,2,5,10,20]    ;biompft
  midtic = ' - '
  lowtic = '  '
  hightic = ' > '
  formtic = 'f6.2'
  ibw=0 
 endelse
endif
if(igraph ge 7*nplant+1) and (igraph le 8*nplant) then begin
 if ianom eq 0 then begin
  ndiv = 17
  inoveg = 0 
  xtic  = [0.001,0.02,0.05,0.1,0.2,0.5,1,1.5,2,3,4,6,8,10,15,20,25,30]    ;frac*biompft
  midtic = ' - '
  lowtic = '  '
  hightic = ' > '
  formtic = 'f6.2'
  ibw=0  
 endif else begin
  ndiv = 14
  inoveg = 0  
  xtic  = [-20,-10,-5,-2,-1,-0.5,-0.1,0,0.1,0.5,1,2,5,10,20]    ;frac*biompft
  midtic = ' - '
  lowtic = '  '
  hightic = ' > '
  formtic = 'f6.2'
  ibw=0 
 endelse
endif
if(igraph ge 8*nplant+1) and (igraph le 9*nplant) then begin
  inoveg = 2
  ndiv = 19
  ; xtic  = [-50,-20,0,50,100,200,300,400,600,800,1000,1200,1400,1600,1800,2000,2500,3000,4000,5000]
   xtic  = [-100,-20,0,200,400,500,600,700,800,900,1000,1100,1200,1300,1400,1600,1800,2000,2200,2400]
  ;ndiv = 19 
  ;xtic  = [-20,-10,0,2,10,20,50,75,100,150,200,250,300,350,400,450,500,550,600,650]   ;elev
  midtic = ' - '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'i4' 
  dircol = 1 
  jplalldiv = 0  
endif
if(igraph ge 9*nplant+1) and (igraph le 10*nplant) then begin
  inoveg = 2
  ndiv = 18
  xtic  = [0,1,2,3,4,6,8,10,15,20,25,35,40,45,50,60,70,80,90,100]
  midtic = ' - '
  lowtic = ' < '
  hightic = ' > '
  formtic = 'i3' 
  dircol = 1 
  jplalldiv = 1  
endif


; =========== END OF USER-DEFINED PARAMETERS ==============================
;===========================================================
; automatic definition of ndiv
  sxt = size(xtic)
  ndiv = sxt(1)-1

; =========== DEFINING COLOR SCALE ===================================
  icv = intarr(ndiv+2)
  if dircol gt 0 then for j=0,ndiv+1 do icv(j)=j+1
  if dircol lt 0 then for j=0,ndiv+1 do icv(j)=ndiv+2-j
  
  
  color_scale_1a,r,g,b,igraph,ndiv,nplant,inoveg,ibw,ianom,kgrey

  if ((igraph eq -19) and (imonth eq -1) ) then begin
   if (ianom eq 0) then begin
     color_scale_7,r,g,b,igraph,ndiv,nplant,inoveg,ibw,ianom,kgrey
   endif else begin
     color_scale_9,r,g,b,igraph,ndiv,nplant,inoveg,ibw,ianom,kgrey
   endelse
  endif  
  if ((igraph eq -17) and (imonth eq -1)) then begin
   if (ianom eq 0) then begin
     if (iwin eq 0) then begin
       color_scale_4,r,g,b,igraph,ndiv,nplant,inoveg,ibw,ianom,kgrey 
     endif else begin
       color_scale_7,r,g,b,igraph,ndiv,nplant,inoveg,ibw,ianom,kgrey
     endelse
   endif else begin
     color_scale_9,r,g,b,igraph,ndiv,nplant,inoveg,ibw,ianom,kgrey
   endelse   
  endif
  if ((igraph eq -16) and (imonth eq -1) ) then begin
   if (ianom eq 0) then begin
     color_scale_7,r,g,b,igraph,ndiv,nplant,inoveg,ibw,ianom,kgrey
   endif else begin
     color_scale_9,r,g,b,igraph,ndiv,nplant,inoveg,ibw,ianom,kgrey
   endelse
  endif
      
  if ((igraph eq -33) and (imonth eq -1)) then color_scale_6,r,g,b,igraph,ndiv,nplant,inoveg,ibw,ianom,kgrey
  if igraph le -41 then color_scale_5,r,g,b,igraph,ndiv,nplant,inoveg,ibw,ianom,kgrey
  if igraph eq -60 then color_scale_5,r,g,b,igraph,ndiv,nplant,inoveg,ibw,ianom,kgrey 
  if igraph eq -57 then color_scale_8,r,g,b,igraph,ndiv,nplant,inoveg,ibw,ianom,kgrey
  if ((igraph ge 1) and (igraph le nplant)) then begin 
   if (ianom eq 0) then begin
     color_scale_7,r,g,b,igraph,ndiv,nplant,inoveg,ibw,ianom,kgrey
   endif else begin
     color_scale_9,r,g,b,igraph,ndiv,nplant,inoveg,ibw,ianom,kgrey
   endelse  
  endif
;  if ((igraph eq -17) and (imonth eq -1) and (iwin eq 0)) then begin
;   color_scale_4,r,g,b,igraph,ndiv,nplant,inoveg,ibw,ianom,kgrey
;  endif else begin
;   if ((igraph eq -16) and (imonth eq -1) and (ianom eq 0) ) then begin
;    color_scale_7,r,g,b,igraph,ndiv,nplant,inoveg,ibw,ianom,kgrey
;   endif else begin  
;    if ((igraph eq -33) and (imonth eq -1)) then begin
;     color_scale_6,r,g,b,igraph,ndiv,nplant,inoveg,ibw,ianom,kgrey
;    endif else begin
;     if igraph eq -60 then begin 
;      color_scale_5,r,g,b,igraph,ndiv,nplant,inoveg,ibw,ianom,kgrey
;     endif else begin
;      color_scale_1,r,g,b,igraph,ndiv,nplant,inoveg,ibw,ianom,kgrey
;     endelse
;    endelse
;   endelse
;  endelse
;  if igraph eq -57 then color_scale_8,r,g,b,igraph,ndiv,nplant,inoveg,ibw,ianom,kgrey
  if (igraph le -63) or (igraph eq -64) then color_scale_5,r,g,b,igraph,ndiv,nplant,inoveg,ibw,ianom,kgrey

if zerogrey eq 1 then begin
  tvlct,r,g,b,/get
  r(zerocol) = 200      
  g(zerocol) = 200     
  b(zerocol) = 200
  tvlct,r,g,b
endif
  
; =========== DEFINING jpl_div vector ==========================================
; jpl_div = vector of ndiv+2 components
;           components j for which jpl_div(j)=0 are not plotted in the legend
;           of color scale on the map
; ==============================================================================
  jpl_div = intarr(ndiv+2)
  if jplalldiv eq 0 then for j=0,ndiv+1 do jpl_div(j)=0 else for j=0,ndiv+1 do jpl_div(j)=1 
    
;===============================================================================
; loop over icomp : simulation + reference to calculate anomalies
;===============================================================================

if ianom eq 0 then icomp_max = 0 else icomp_max = 1

for icomp = 0, icomp_max do begin

  if icomp eq 0 then begin
     pathcres0 = pathcres
     pathclim0 = pathclim
     pathtext0 = pathtext
     pathlu0 = pathlu
     pathfcr0 = pathfcr     
     ext_clim0 = ext_clim
     ext_txt0 = ext_txt  
     ext_res0 = ext_res
     ext_lu0 = ext_lu
     ext_fcr0 = ext_fcr          
  endif else begin    
     pathcres0 = pathrefcres
     pathclim0 = pathrefclim
     pathtext0 = pathreftext
     pathlu0 = pathreflu
     pathfcr0 = pathreffcr          
     ext_clim0 = ext_refclim
     ext_txt0 = ext_reftxt  
     ext_res0 = ext_refres
     ext_lu0 = ext_reflu
     ext_fcr0 = ext_reffcr     
  endelse
  
;===============================================================================
; close all files before opening them
;===============================================================================

  
  close,1
  close,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,30,31,32,33,34
  close,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,52,53,54,55,60,61,62,81
   

;===============================================================================
; opening files
;===============================================================================

      
   file1=pathcres0+'npp'+ext_res0
   file10=pathcres0+'gdd'+ext_res0
   file11=pathcres0+'xlai_min_max'+ext_res0
   file12=pathcres0+'biome'+ext_res0
   file13=pathcres0+'frcC13'+ext_res0
   file14=pathcres0+'pixfrcC13'+ext_res0
   file15=pathcres0+'Cveg'+ext_res0
   file16=pathcres0+'Csoil'+ext_res0
   if ifrac eq 0 then begin
    file17=filefrac0 
   endif else begin
    file17=pathcres0+'frac'+ext_res0 
   endelse
   file18=pathcres0+'pfire'+ext_res0
   file19=pathcres0+'aburn'+ext_res0
   
   file20=pathcres0+'laimth'+ext_res0
   file21=pathcres0+'nppmth'+ext_res0
   file22=pathcres0+'gppmth'+ext_res0
   file23=pathcres0+'water_yr'+ext_res0 
   file24=pathcres0+'Tdmin'+ext_res0
   file25=pathcres0+'Tmmin'+ext_res0
   file26=pathcres0+'nepmth'+ext_res0 
   file27=pathcres0+'ramth'+ext_res0 
   file28=pathcres0+'nbpmth'+ext_res0     
   if jbagtol eq 0 then begin
     file30=pathcres0+'pft_carbon'+ext_res0
   endif else begin
     file30=filebagtol
   endelse
   file31=pathcres0+'biome_carbon'+ext_res0
   
   file32=pathcres0+'alb'+ext_res0
   file33=pathcres0+'pet'+ext_res0
   file34=pathcres0+'aet'+ext_res0
   file35=pathcres0+'run'+ext_res0
   file36=pathcres0+'pco2soil_NM'+ext_res0
   file37=pathcres0+'flca_NM'+ext_res0
   file38=pathcres0+'sw'+ext_res0
   file39=pathcres0+'ts'+ext_res0       
   
   file40=pathtext0+'ecotxt'+ext_txt0 

   file41=pathclim0+'tem'+ext_clim0
   file42=pathclim0+'dte'+ext_clim0      
   file43=pathclim0+'prc'+ext_clim0
   file44=pathclim0+'shr'+ext_clim0
   file45=pathclim0+'rhu'+ext_clim0
   file46=pathclim0+'wnd'+ext_clim0
   
   file47=pathcres0+'xh'+ext_res0
   file48=pathcres0+'xle'+ext_res0
   file49=pathcres0+'snd'+ext_res0
   
   if isol eq 0 then begin 
      file50=pathcres0+'fsol'+ext_res0
   endif else begin
      file50=pathclim0+'fsol'+ext_clim0
   endelse
; unit 51 is not available (used for site data)   
   file52=pathcres0+'rn'+ext_res0
   file53=pathcres0+'biommth'+ext_res0
    
   file54=pathclim0+'lpr'+ext_clim0
   file55=pathclim0+'qv'+ext_clim0
   
   file61=pathlu0+'landuse'+ext_lu0
   file62=pathfcr0+'frac_crop'+ext_fcr0   
                 
   file81=pathcres0+'yield'+ext_res0
      
   if kplot eq -60 then file60 = user_file
   
   file80=file_polygon

   
  if (kplot eq 9) then begin
    openr,15,file15  
    openr,40,file40
  endif
  
  if (kplot eq 8) then openr,15,file15  
 
  if (kplot eq 7) then openr,15,file15
   
  if (kplot eq 10) then openr,81,file81     
    
  if (kplot ge -10) then openr,1,file1

  if (kplot eq -1) then openr,10,file10
  if (kplot eq -3 or kplot eq -4) then openr,11,file11
  if (kplot eq -5) then openr,12,file12
  if (kplot eq 5) then openr,13,file13
  if (kplot eq -6) then openr,14,file14
  if (kplot eq -7 or kplot eq -9) then openr,15,file15
  if (kplot eq -7 or kplot eq -8) then openr,16,file16

  if (kplot ge -10) then openr,17,file17

  if (kplot le -11 and kplot ge -14) then begin 
   openr,18,file18
   openr,19,file19
  endif

  if (kplot eq -15) then openr,20,file20
  if (kplot eq -16) then openr,21,file21
  if (kplot eq -17) then openr,22,file22
  if (kplot eq -18) then openr,26,file26
  if (kplot eq -19) then openr,27,file27
  if (kplot eq -20) then openr,28,file28       

  

  if ((kplot eq -1) or (kplot eq -56) or (kplot eq -62) or (kplot ge 1)) then openr,30,file30
  if (kplot eq -5) then openr,31,file31
  
  if (kplot eq -59 or kplot eq -21) then openr,40,file40
 
  if (kplot eq -22) then openr,10,file10
  ;if (kplot eq -22) then openr,10,'/data/francois/clim/0k/New_26PFT/tmincor/nceplr/gdd_cor.res'

  if (kplot eq -23) then begin
    openr,24,file24
    openr,25,file25
  endif
  
  if (kplot eq -24) then openr,41,file41
  if (kplot eq -25) then openr,42,file42  
  if (kplot eq -26) then openr,43,file43
  if (kplot eq -27) then openr,44,file44
  if (kplot eq -28) then openr,45,file45
  if (kplot eq -29) then openr,46,file46
  
  if (kplot eq -30) then openr,32,file32
  if (kplot eq -31) then openr,33,file33  
  if (kplot eq -32) then openr,34,file34
  if (kplot eq -33) then openr,35,file35
  if (kplot eq -34) then openr,38,file38
  if (kplot eq -35) then openr,39,file39

  if (kplot eq -52) then openr,55,file55
  if (kplot eq -53) then openr,54,file54        
  if (kplot eq -54) then openr,36,file36
  if (kplot eq -55) then openr,37,file37
  
  if (kplot eq -36) then openr,47,file47
  if (kplot eq -37) then openr,48,file48
  if (kplot eq -38) then openr,49,file49
  if (kplot eq -39) then openr,50,file50
; unit 51 is not available (used for site data)  
  if (kplot eq -40) then openr,52,file52    
  if (kplot eq -41) then openr,53,file53   
    
  if (kplot eq -56) then openr,81,file81
  if (kplot eq -57) then begin
   openr,1,file1  
   openr,17,file17
  endif
  if (kplot eq -58) then openr,23,file23  
  if (kplot eq -60) then openr,60,file60
  
  if (kplot eq -61) then openr,61,file61
  if (kplot eq -62) then openr,62,file62
  
  if (kplot eq -63) then begin
    openr,15,file15
    openr,17,file17
  endif
  
  if (kplot eq -64) then openr,16,file16   
  
if (icomp eq 0) then begin

;===============================================================================
; read pft names from unit 30
;    tic_lab=labels used when iclass=1 (ndiv+2 values)
;===============================================================================
   

  if ((igraph eq -1) or (igraph eq -56) or (igraph eq -62) or (igraph ge 1)) then begin
   pft_lab=strarr(nplant+2)
   pft_lab(0)='Ice or Polar Desert'
   pft_lab(1)='No vegetation'
   stdata=' '
   if jbagtol eq 0 then begin
    readf,30,stdata,format='(a50)'
    readf,30,stdata,format='(a50)'
   endif
   readf,30,stdata,format='(a50)'
   for k= 2, nplant+1 do begin
     readf,30,stdata,format='(a50)'
     pft_lab(k)=stdata
   endfor      
   if (igraph eq -1) then tic_lab=pft_lab
   if (igraph eq -62) then begin
     if imonth gt 0 then begin
       monthname=' '+pft_lab(1+ngrass+ntree+imonth)
       graphname=graphname+monthname
     endif else begin
        if imonth eq 0 then graphname=graphname+' total fraction of crops and pastures'
	if imonth eq -1 then graphname=graphname+' total fraction of crops'
	if imonth eq -2 then graphname=graphname+' total fraction of pastures'
     endelse 
   endif
  endif

;===============================================================================
; read biome names from unit 31
;===============================================================================

  if (igraph eq -5) then begin
   tic_lab=strarr(nbiome)  
   stdata=' '
   readf,31,stdata,format='(a50)'
   readf,31,stdata,format='(a50)'
   readf,31,stdata,format='(a50)'
   for k= 0, nbiome-1 do begin
     readf,31,kbio,stdata,format='(i2,1x,a47)'
     tic_lab(k)=stdata
   endfor
  endif  


  if (igraph ge 5*nplant+1) and (igraph le 6*nplant) then tic_lab= [' Absence',' Presence']

  if (igraph le 0) then varname='' 
  if (igraph eq -56) then varname=pft_lab(1+imonth)   
  if (igraph ge 1) and (igraph le nplant) then varname='!c ['+pft_lab(1+igraph)+']'
  if (igraph ge nplant+1) and (igraph le 2*nplant) then varname='!c ['+pft_lab(1+igraph-nplant)+']'
  if (igraph ge 2*nplant+1) and (igraph le 3*nplant) then varname='!c ['+pft_lab(1+igraph-2*nplant)+']'
  if (igraph ge 3*nplant+1) and (igraph le 4*nplant) then varname='!c ['+pft_lab(1+igraph-3*nplant)+']'
  if (igraph ge 4*nplant+1) and (igraph le 5*nplant) then varname='!c ['+pft_lab(1+igraph-4*nplant)+']'
  if (igraph ge 5*nplant+1) and (igraph le 6*nplant) then varname='!c ['+pft_lab(1+igraph-5*nplant)+']'
  if (igraph ge 6*nplant+1) and (igraph le 7*nplant) then varname='!c ['+pft_lab(1+igraph-6*nplant)+']'
  if (igraph ge 7*nplant+1) and (igraph le 8*nplant) then varname='!c ['+pft_lab(1+igraph-7*nplant)+']'  
  if (igraph ge 8*nplant+1) and (igraph le 9*nplant) then varname='!c ['+pft_lab(1+igraph-8*nplant)+']'
  if (igraph ge 9*nplant+1) and (igraph le 10*nplant) then varname='!c ['+pft_lab(1+igraph-9*nplant)+']'      
 
   lat    = fltarr(dim0)
   lg     = fltarr(dim0)
   var_V  = fltarr(dim0)
   var_V0 = fltarr(dim0)  
   npp    = fltarr(dim1)
   frac   = fltarr(dim1)
   fnpp   = fltarr(dim1)
   laimin = fltarr(dim1)  
   laimax = fltarr(dim1)
   flaimx = fltarr(dim1)
   frc13  = fltarr(dim1) 
   cveg   = fltarr(dim1)
   csoil  = fltarr(dim1)
   yield  = fltarr(dim1)
   varm  = fltarr(nmonth)
   varw  = fltarr(13)
   if (igraph eq -60) then user_data=fltarr(user_ncol)
   
endif 

; ======  READING INPUT DATA ===========================================

   
  for i = long(0), dim0-1 do begin


   
   if(igraph eq -1 or igraph eq -22) then readf,10,a1,a2,gdd0,gdd5
   if(igraph eq -3 or igraph eq -4) then readf,11,a1,a2,laimin,laimax
   if(igraph eq -5) then readf,12,a1,a2,jbio


   if(igraph eq -59 or igraph eq -21) then begin
     readf,40,iii,a1,a2,isu,clay,silt,sand,elev,scol
   endif   
   
   
   if(igraph eq -23) then begin
     readf,24,a1,a2,Tdmin,Tdmax,Tdnmin,Tddmax
     readf,25,a1,a2,Tmmin,Tmmax
   endif
   
   if (igraph ge -10) then begin
   
     readf,1,a1,a2,npp     
     readf,17,a1,a2,frac      
     pix_npp=0.
     laigrass = 0.
     laitree = 0.    
     for j= long(0),nplant-1 do begin
      fnpp(j)=frac(j)*npp(j)
      flaimx(j)=frac(j)*laimax(j)
      pix_npp = pix_npp+fnpp(j)
      if j le ngrass-1 then laigrass=laigrass+flaimx(j) else laitree=laitree+flaimx(j)
     endfor 
     laitot = laigrass+laitree            

     if igraph eq 0 then begin
      a3 = pix_npp
     endif

     if (igraph ge 1) and (igraph le nplant) then begin
      a3 = npp(igraph-1)
     endif 

     if (igraph ge nplant+1) and (igraph le 2*nplant) then begin
      a3 = frac(igraph-1-nplant)
     endif 

     if (igraph ge 2*nplant+1) and (igraph le 3*nplant) then begin
      if pix_npp gt 0. then begin
       a3 = 100.*fnpp(igraph-1-2*nplant)/pix_npp
      endif else begin
       a3 = -15.
      endelse
     endif

     if (igraph ge 3*nplant+1) and (igraph le 4*nplant) then begin
       a3 = fnpp(igraph-1-3*nplant)
     endif 

     if (igraph ge 4*nplant+1) and (igraph le 5*nplant) then begin
      readf,13,a1,a2,frc13
      if pix_npp gt 0. then begin
       a3 = frc13(igraph-1-4*nplant)
      endif else begin
        a3 = -110.
      endelse
     endif 

     if (igraph ge 5*nplant+1) and (igraph le 6*nplant) then begin
      a3 = npp(igraph-1-5*nplant)
     endif
     
     if (igraph ge 6*nplant+1) and (igraph le 7*nplant) then begin
      readf,15,a1,a2,cveg
      a3 = cveg(igraph-1-6*nplant)/1000.
     endif
     
     if (igraph ge 7*nplant+1) and (igraph le 8*nplant) then begin
      readf,15,a1,a2,cveg      
      a3 = frac(igraph-1-7*nplant)*cveg(igraph-1-7*nplant)/1000.
     endif
     
     if (igraph ge 8*nplant+1) and (igraph le 9*nplant) then begin
      readf,15,a1,a2,cveg
      readf,40,iii,aaa,bbb,isu,clay,silt,sand,elev,scol      
      if (cveg(igraph-1-8*nplant)/1000.) le abiothres then begin
       a3 = -500.
      endif else begin
       a3 = elev
      endelse
     endif
     
     if (igraph ge 9*nplant+1) and (igraph le 10*nplant) then begin
      readf,81,a1,a2,yield    
      a3 = yield(igraph-1-9*nplant)
     endif                                     

     if igraph eq -1 then begin         
      tmax = 0.
      jpft = 0
      for j= long(0),nplant-1 do begin
       if (fnpp(j) gt tmax) then begin
        tmax = fnpp(j)
        jpft=j+1
       endif
      endfor
      a3 = float(jpft)
      if (jpft eq 0) and (gdd5 lt 50) then a3 = -1     
     endif 
     if igraph eq -2 then begin
      tree_fnpp = 0.    
      for j= long(ngrass),nplant-1 do begin
       tree_fnpp=tree_fnpp+fnpp(j)
      endfor
      if pix_npp gt 0. then begin
       a3 = 100.*tree_fnpp/pix_npp
      endif else begin
       a3 = -15.
      endelse     
     endif
     if igraph eq -3 then begin
      if pix_npp gt 0. then begin
       a3 = laitot
      endif else begin
       a3 = -15.
      endelse
     endif
     if igraph eq -4 then begin
      if pix_npp gt 0. then begin
       a3 = laitree
      endif else begin
       a3 = -15.
      endelse
     endif 
     if igraph eq - 5 then a3 = jbio
     if igraph eq -6 then begin
      readf,14,a1,a2,pix_frc13
      if pix_npp gt 0. then begin
       a3 = dc13_atm-pix_frc13
      endif else begin
       a3 = -110.
      endelse
     endif    

     if (igraph eq -7) then begin
      readf,15,a1,a2,cveg
      pix_cveg = 0.
      for j= long(0),nplant-1 do begin
        pix_cveg=pix_cveg+frac(j)*cveg(j)
      endfor
      if isoilfile eq 0 then begin
        readf,16,a1,a2,csoil 
        pix_csoil = 0.
        for j= long(0),nplant-1 do begin
          pix_csoil=pix_csoil+frac(j)*csoil(j)
        endfor	
      endif else begin 
        readf,16,a1,a2,pix_csoil
      endelse
      pix_ctot=pix_cveg+pix_csoil
      a3 = pix_ctot/1000.
     endif 
     if (igraph eq -8) then begin
      if isoilfile eq 0 then begin
        readf,16,a1,a2,csoil 
        pix_csoil = 0.
        for j= long(0),nplant-1 do begin
          pix_csoil=pix_csoil+frac(j)*csoil(j)
        endfor	
      endif else begin 
        readf,16,a1,a2,pix_csoil
      endelse     
      a3 = pix_csoil/1000.
     endif               	            
     if (igraph eq -9) then begin
      readf,15,a1,a2,cveg
      pix_cveg = 0.
      for j= long(0),nplant-1 do begin
        pix_cveg=pix_cveg+frac(j)*cveg(j)
      endfor
      a3 = pix_cveg/1000.
     endif        
     if (igraph eq -10) then begin
      gr_npp =0.
      for j= long(0),ngrass-1 do begin
       gr_npp = gr_npp + fnpp(j)
      endfor
      a3 = gr_npp
     endif
       
   endif
    
   if ((igraph le -11) and (igraph ge -20)) or ((igraph le -24) and (igraph ge -55)) then begin
      if igraph eq -11 then iunit = 19
      if igraph eq -12 then iunit = 18
      if igraph eq -13 then iunit = 19
      if igraph eq -14 then iunit = 19
      if igraph eq -15 then iunit = 20
      if igraph eq -16 then iunit = 21
      if igraph eq -17 then iunit = 22
      if igraph eq -18 then iunit = 26
      if igraph eq -19 then iunit = 27      
      if igraph eq -20 then iunit = 28      
      
      if igraph eq -24 then iunit = 41
      if igraph eq -25 then iunit = 42  
      if igraph eq -26 then iunit = 43
      if igraph eq -27 then iunit = 44
      if igraph eq -28 then iunit = 45
      if igraph eq -29 then iunit = 46
  
      if igraph eq -30 then iunit = 32
      if igraph eq -31 then iunit = 33  
      if igraph eq -32 then iunit = 34
      if igraph eq -33 then iunit = 35
      if igraph eq -34 then iunit = 38
      if igraph eq -35 then iunit = 39
      
      if igraph eq -36 then iunit = 47
      if igraph eq -37 then iunit = 48
      if igraph eq -38 then iunit = 49
      if igraph eq -39 then iunit = 50
      if igraph eq -40 then iunit = 52                               
      if igraph eq -41 then iunit = 53

      if igraph eq -52 then iunit = 55
      if igraph eq -53 then iunit = 54                        
      if igraph eq -54 then iunit = 36
      if igraph eq -55 then iunit = 37
        
      readf,iunit,a1,a2,varm

; change units for specific humidity (kg/kg -> g/kg)
      if igraph eq -52 then for j = long(0),nmonth-1 do varm(j)=varm(j)*1000.
      
; change units for lapse rate (oC/m -> oC/km)
      if igraph eq -53 then for j = long(0),nmonth-1 do varm(j)=varm(j)*1000.      
      
      areapix = 1.23604116d+10*dlg*dlt*cos(a2*3.14159/180.)
      if igraph eq -55 then for j = long(0),nmonth-1 do varm(j)=varm(j)/areapix
       
      if igraph eq -11 then imonth = -1
      if imonth eq 0 then begin
       a3 = 0
       for j= long(0),nmonth-1 do begin
        a3 = a3 + varm(j)/float(nmonth)
       endfor
      endif
      if (imonth ge 1) and (imonth le nmonth) then a3 = varm(imonth-1)      
      if (imonth eq 13) then a3 = (varm(11)+varm(0)+varm(1))/3.
      if (imonth eq -13) then a3 = (varm(11)+varm(0)+varm(1))
      if (imonth eq 14) then a3 = (varm(2)+varm(3)+varm(4))/3.
      if (imonth eq -14) then a3 = (varm(2)+varm(3)+varm(4))
      if (imonth eq 15) then a3 = (varm(5)+varm(6)+varm(7))/3.
      if (imonth eq -15) then a3 = (varm(5)+varm(6)+varm(7)) 
      if (imonth eq 16) then a3 = (varm(8)+varm(9)+varm(10))/3.
      if (imonth eq -16) then a3 = (varm(8)+varm(9)+varm(10))   
      
      if (imonth eq 17) or (imonth eq -17) then begin
       a3 = 0
       for i_mth= 0, n_mth-1 do begin
        j = v_mth(i_mth)-1	
        if (imonth eq 17) then begin
	  a3 = a3 + varm(j)/float(n_mth)
	endif else begin
	  a3 = a3 + varm(j)
	endelse
       endfor      
      endif
                           
      if imonth eq -1 then begin
       a3 = 0
       for j= long(0),nmonth-1 do begin
        a3 = a3 + varm(j)
       endfor
      endif
      if imonth eq -2 then begin
       a3 = -1.d+20
       for j= long(0),nmonth-1 do begin
        if(varm(j) ge a3) then a3 = varm(j)
       endfor
      endif
      if imonth eq -3 then begin
       a3 = 1.d+20
       for j= long(0),nmonth-1 do begin
        if(varm(j) le a3) then a3 = varm(j)
       endfor
      endif 
      ; fire return interval
      if igraph eq -11 then begin
       if a3 le 1.e-6 then fireint = 10000000000. else fireint = areapix/a3
       if fireint gt 10000000000. then fireint = 10000000000.
       a3 = fireint
      endif      
      ; conversion of area burned into hectares     
      if igraph eq -13 then a3 = a3/1.e+4
      ; percentage of pixel area burned 
      if igraph eq -14 then begin
        if areapix gt 1.e-4 then a3=100.*a3/areapix else a3=0.
      endif   
   endif 
 

   if igraph eq -21 then a3 = elev
   if igraph eq -22 then begin
    if imonth eq 1 then begin
      a3 = gdd0
    endif else begin
      a3 = gdd5
    endelse
   endif
   if igraph eq -23 then begin
    a3 = Tdmin
    if imonth eq 2 then a3 = Tdmax 
    if imonth eq 3 then a3 = Tdnmin
    if imonth eq 4 then a3 = Tddmax
    if imonth eq 5 then a3 = Tmmin
    if imonth eq 6 then a3 = Tmmax
   endif 
      
   if igraph eq -56 then begin
    readf,81,a1,a2,yield     
    a3=yield(imonth-1)
   endif
   
   if (igraph eq -57) then begin
      readf,1,a1,a2,npp
      readf,17,a1,a2,frac      
      pix_npp=0.  
      for j= long(0),nplant-1 do begin
       pix_npp = pix_npp+frac(j)*npp(j)
      endfor      
      a3 = 0
      if pix_npp gt 1.e-5 then begin 
       for k = 0, num_spec-1 do begin
        ispec = vec_spec(k)
	if imonth ne 0 and imonth ne 1 then begin
	  print,'Check the value of imonth, it must be equal to 0 or 1 with kplot=-57'
	  print,'Program stop'
	  stop
	endif else begin
         if imonth eq 0 then begin
	   if npp(ispec-1) ge anppthres then a3 = a3 + 1
	 endif
         if imonth eq 1 then begin
	   rnppk = npp(ispec-1)/pix_npp
	   if rnppk ge rnppthres then a3 = a3 + 1
	 endif
	endelse
       endfor
      endif 
   endif
   
   if (igraph eq -58) then begin
      readf,23,iii,a1,a2,varw
      if(imonth eq 1) then a3=varw(11)
      if(imonth eq 2) then a3=varw(12)
      if(imonth eq 3) then a3=varw(3)
   endif  
   
   if (igraph eq -59) then begin
     if imonth eq -1 then a3 = sand
     if imonth eq -2 then a3 = silt
     if imonth eq -3 then a3 = clay
     if imonth eq -4 then begin
      scolour = 100.*scol
      a3 = scolour
     endif
   endif    
      
   if igraph eq -60 then begin
    readf,60,a1,a2,user_data
    a3 = user_data(user_jcol-1)     
   endif
   
   if igraph eq -61 then begin
    frlu=fltarr(nlu)
    readf,61,a1,a2,frlu
    if imonth eq -1 then a3=total(frlu)
    if imonth eq 0 then a3=mean(frlu)
    if imonth ge 1 then a3 = frlu(imonth-1)     
   endif
   
   if igraph eq -62 then begin
    frcrop=fltarr(ncrop)
    frpast=fltarr(npast)    
    readf,62,a1,a2,frcrop,frpast
    if imonth le 0 then begin
      if imonth eq 0 then a3=total(frcrop)+total(frpast)
      if imonth eq -1 then a3=total(frcrop)
      if imonth eq -2 then a3=total(frpast)
    endif else begin
      if imonth le ncrop then a3=frcrop(imonth-1) else a3=frpast(imonth-ncrop-1) 
    endelse    
   endif         

   if (igraph eq -63) then begin
     readf,15,a1,a2,cveg
     readf,17,a1,a2,frac
     if imonth eq 1 then begin
       np1=1
       np2=nherb
     endif
     if imonth eq 2 then begin
       np1=nherb+1
       np2=nherb+nshrb
     endif 
     if imonth eq 3 then begin
       np1=nherb+nshrb+1
       np2=nbag
     endif
     if imonth eq 4 then begin
       np1=1
       np2=nbag
     endif
     if imonth eq 5 then begin
       np1=nbag+1
       np2=nbag+ncrop
     endif
     if imonth eq 6 then begin
       np1=nbag+ncrop+1
       np2=nplant
     endif
     if imonth eq 7 then begin
       np1=1
       np2=nplant
     endif
     a3=0.  
     for j= long(np1),long(np2) do begin
       a3 = a3+frac(j-1)*cveg(j-1)
     endfor                                                
   endif 
         
   if (igraph eq -64) then begin
     readf,16,a1,a2,cstot,clit,clitl,clitw,soilc
     if imonth eq 1 then a3 = cstot 
     if imonth eq 2 then a3 = clit
     if imonth eq 3 then a3 = clitl
     if imonth eq 4 then a3 = clitw
     if imonth eq 5 then a3 = soilc                                                
   endif 
   
   if a1 lt -180. then a1 = a1 + 360.
   if a1 ge  180. then a1 = a1 - 360.
   lg(i)  = a1
   lat(i) = a2                              
   var_V(i) = a3 * facmul 
   
  endfor           ; i : pixel
  
  
 
  if icomp eq 0 then begin
    for i = long(0), dim0-1 do var_V0(i) = var_V(i)
  endif else begin    
    if ianom eq 1 then for i = long(0), dim0-1 do var_V(i) = var_V0(i)-var_V(i)
    if ianom eq 2 then begin
      for i = long(0), dim0-1 do begin
       if abs(var_V(i)) le 1.e-10 then begin
          var_V(i) = 0.
       endif else begin 
	  var_V(i) = abs(var_V0(i)/var_V(i))
       endelse
      endfor
    endif  
  endelse
  
 endfor            ; icomp

; ======= READING SITE VALUES ========================================

if (kplot gt 0) and (ksite eq 1) then begin

site_lat = fltarr(nsite)
site_long = fltarr(nsite)
frc_grass = fltarr(ngrass)
frc_tree = fltarr(ntree)
site_frac = fltarr(nsite,nbag)
close,51
openr,51,filesite
    
for js = 0, nsite-1 do begin
 if nshrb ge 1 then begin
  frc_shrub = fltarr(nshrb) 
  readf,51,a1,a2,frc_shrub,frc_tree
  for jpl = 0, ngrass-nshrb-1 do frc_grass(jpl)=0.
  for jpl = ngrass-nshrb,ngrass-1 do frc_grass(jpl)=frc_shrub(jpl-(ngrass-nshrb))  
 endif else begin
  readf,51,a1,a2,frc_tree
  for jpl = 0, ngrass-1 do frc_grass(jpl)=0.  
 endelse
 site_long(js)=a1
 site_lat(js)=a2
 for jpl = 0, nbag-1 do begin
  if jpl le ngrass-1 then site_frac(js,jpl) = frc_grass(jpl) else site_frac(js,jpl)=frc_tree(jpl-ngrass)
 endfor
endfor

close,51

endif

; ======= CLOSE FILES ====================================================  
close,1
close,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24,25,26,27,28,30,31,32,33,34
close,35,36,37,38,39,40,41,42,43,44,45,46,47,48,49,50,52,53,54,55,60,61,62,81




; ======= PLOT MAP =======================================================


!p.multi=[0,1,1]

if (ktck_lab eq 0) then begin
 long_lab=fltarr(nlong_grid+1)
 del_long=(log2-log1)/nlong_grid
 for k=0,nlong_grid do long_lab(k)=log1+k*del_long
 lat_lab=fltarr(nlat_grid+1)
 del_lat=(lat2-lat1)/nlat_grid
 for k=0,nlat_grid do lat_lab(k)=lat1+k*del_lat
endif

if igpro eq 0 then begin

 plot,[log1,lat1],[log1,lat1],xrange=[log1,log2],yrange=[lat1,lat2],/nodata,$
 xstyle=1,ystyle=1,xmargin=[6,41],ymargin=[4,ymarup],xticks=nlong_grid,$
 xtickv=long_lab,yticks=nlat_grid,ytickv=lat_lab,$
 xtitle='Longitude (deg.)',ytitle='Latitude (deg.)',xcharsize=0.6,ycharsize=0.6$
 ,yticklen=-0.015,xticklen=-0.015
                           ; xmargin=[14,16]

 oplot,[log1,log2],[lat1,lat1],thick=2
 oplot,[log1,log1],[lat1,lat2],thick=2
 oplot,[log1,log2],[lat2,lat2],thick=2
 oplot,[log2,log2],[lat1,lat2],thick=2
 
endif else begin
 
; map_set,lat2,log1,limit=[lat1,log1,lat2,log2],name=projection_name,$
; ellipsoid=[6378137.0,0.00669437999014,0.9996],$
; xmargin=[2,46],ymargin=[2,ymarup],charsize=0.9,title=''

 if i_projcenter eq 0 then begin
   map_set,limit=[lat1,log1,lat2,log2],name=projection_name,$
   ellipsoid=[6378137.0,0.00669437999014,0.9996],$
   xmargin=[2,46],ymargin=[2,ymarup],charsize=0.9,title='' 
 endif else begin   
   map_set,p0_lat,p0_long,limit=[lat1,log1,lat2,log2],name=projection_name,$
   ellipsoid=[6378137.0,0.00669437999014,0.9996],$
   xmargin=[2,46],ymargin=[2,ymarup],charsize=0.9,title=''
 endelse

endelse

close,80
if (ipoly ne 0) then openr,80,file80
 ;   print,file80
 
    for i = long(0.), dim0-1 do begin
         if (ipoly ne 0) then begin
	  polystring='  '
          readf,80,polystring
          reads,polystring,a1,a2,nver
	;  print,i,lg(i),lat(i),a1,a2,nver
          longv=fltarr(nver)
          latv=fltarr(nver)
          reads,polystring,a1,a2,nver,longv,latv  
	 endif     
      if lg(i) ge log1 and lg(i) le log2 then begin
       if lat(i) ge lat1 and lat(i) le lat2 then begin 
      ;    print,lg(i),lat(i),log1,log2,lat1,lat2
         if ipoly eq 0 then begin    
          lg1 = lg(i)  - dlg/2.
          lg2 = lg(i)  + dlg/2.
          lt1 = lat(i) - dlt/2.
          lt2 = lat(i) + dlt/2.
          if lg1 lt log1 then lg1=log1      
          if lg2 gt log2 then lg2=log2
          if lt1 lt lat1 then lt1=lat1
          if lt2 gt lat2 then lt2=lat2
	  lgvec=[lg1,lg2,lg2,lg1,lg1]
	  ltvec=[lt1,lt1,lt2,lt2,lt1]
	 endif else begin   
	  lgvec=fltarr(nver+1)
	  ltvec=fltarr(nver+1)
	 ; print,i
	;  print,a1,a2,nver,longv,latv
          for nv=0,nver-1 do begin
;	    if longv(nv) lt -180. then longv(nv) = longv(nv) + 360.
;           if longv(nv) ge  180. then longv(nv) = longv(nv) - 360.
	   if longv(nv) lt log1 then longv(nv)=log1      
           if longv(nv) gt log2 then longv(nv)=log2
           if latv(nv) lt lat1 then latv(nv)=lat1
           if latv(nv) gt lat2 then latv(nv)=lat2
	   lgvec(nv)=longv(nv)
	   ltvec(nv)=latv(nv)
	  endfor
	  lgvec(nver)=lgvec(0)
	  ltvec(nver)=ltvec(0)
	 endelse 
	   
	areapix = 1.23604116d+10*dlg*dlt*cos(lat(i)*3.14159/180.)
         
        for kk = 0, ndiv do begin
          if var_V(i) le xtic(0) then begin 
	     ic = icv(0) 
	     kdiv = 0
	  endif else begin 
	   if var_V(i) ge xtic(kk) then begin 
	     ic = icv(kk+1)
	     kdiv = kk+1
	   endif
	  endelse 
        endfor
        jpl_div(kdiv)=1
        polyfill,lgvec,ltvec,color=ic
	if (ipoly eq 2) then oplot,lgvec,ltvec
       endif
      endif

    endfor
    
    close,80
    
  xyouts,longlab,latlab,label,alignment=0.,charsize = 1.0
  
; ======= PLOT DISTRIBUTION DATA ==========================================

  if jdis ne 0 then begin
    icol = 202
    tvlct,r,g,b,/get
    r(icol) = 255 
    g(icol) = 0  
    b(icol) = 0
    tvlct,r,g,b  
    for jd = 0, ndis-1 do begin
       lg1 = dislong(jd)
       lg2 = dislong(jd)
       lt1 = dislat(jd)
       lt2 = dislat(jd)
       oplot,[lg1,lg2],[lt1,lt2],psym=3,color=icol             
    endfor
  endif     
  
; ======= PLOT SITE DATA ==================================================

  if (kplot gt 0) and (ksite eq 1) then begin
  if (iplant le nbag) then begin 

       
   for js = 0, nsite-1 do begin
    frdat = site_frac(js,iplant-1)
    
    lg1 = site_long(js)
    lg2 = site_long(js)
    lt1 = site_lat(js)
    lt2 = site_lat(js)    
    if (frdat ge fsite_thres)then begin 
;     for kk = 0, ndiv do begin
;         if frdat le xtic(0) then begin 
;	     ic = icv(0) 
;	     kdiv = 0
;	  endif else begin 
;	   if frdat ge xtic(kk) then begin 
;	     ic = icv(kk+1)
;	     kdiv = kk+1
;	   endif
;	  endelse         
;     endfor
;     jpl_div(kdiv)=1
   

     radius=0.5
     per=findgen(33)*(!pi*2./32.)    
     aa=radius*cos(per)
     bb=radius*sin(per)
     usersym,aa,bb,thick=2.0,color=200
     oplot,[lg1,lg2],[lt1,lt2],psym=8      
    endif else begin 
;     oplot,[lg1,lg2],[lt1,lt2],psym=4
    endelse
    
   endfor
  endif
  endif    
       
  
; ======= PLOT LOCALITIES =================================================  
  if jloc ne 0 then begin
    for jl = 0, nloc-1 do begin
      icol = 201
      tvlct,r,g,b,/get
      r(icol) = 0 
      g(icol) = 0  
      b(icol) = 0
      tvlct,r,g,b
      if locprt(jl) ne 0 then begin
       lg1 = loclong(jl)
       lg2 = loclong(jl)
       lt1 = loclat(jl)
       lt2 = loclat(jl)
       dist=5.
       lg3 = lg1 
       lt3 = lt1+dist*dlt
       if locplp(jl) eq 1 then begin
         lg3 = lg1+2.*dist*dlg 
         lt3 = lt1+dist*dlt
       endif       
       if locplp(jl) eq 2 then begin
         lg3 = lg1+2.*dist*dlg 
         lt3 = lt1-dist*dlt
       endif
       if locplp(jl) eq 3 then begin
         lg3 = lg1+2.*dist*dlg 
         lt3 = lt1-4.*dist*dlt
       endif       
       if locplp(jl) eq 4 then begin
         lg3 = lg1 
         lt3 = lt1-4.*dist*dlg
       endif
       if locplp(jl) eq 5 then begin
         lg3 = lg1-2.*dist*dlg 
         lt3 = lt1-4.*dist*dlg
       endif       
       if locplp(jl) eq 6 then begin
         lg3 = lg1-2.*dist*dlg 
         lt3 = lt1-dist*dlt
       endif
       if locplp(jl) eq 7 then begin
         lg3 = lg1-2.*dist*dlg 
         lt3 = lt1+dist*dlt
       endif                            
       radius=0.3
       per=findgen(33)*(!pi*2./32.)    
       aa=radius*cos(per)
       bb=radius*sin(per)
       usersym,aa,bb,thick=2.0,color=icol,/fill
       oplot,[lg1,lg2],[lt1,lt2],psym=8
       if jloc eq 1 then begin 
         xyouts,lg3,lt3,strtrim(string(locnum(jl)),2),alignment=0.5,color=icol,charsize=0.9,charthick=2 
       endif else begin      
        if jloc eq 2 and locjnm(jl) eq 1 then begin
         xyouts,lg3,lt3,strtrim(locname(jl),2),alignment=0.5,color=icol,charsize=0.9,charthick=2
        endif
       endelse
      endif
    endfor
  endif
  

  
; ======= PLOT GRID -------------------------------------------------------

  if igrid eq 1 then begin
   tvlct,r,g,b,/get
   r(230)=140
   g(230)=140
   b(230)=140
   tvlct,r,g,b
   if igpro eq 0 then begin
    for k=0,nlong_grid do oplot,[long_lab(k),long_lab(k)],[lat1,lat2],line=1
    for k=0,nlat_grid do oplot,[log1,log2],[lat_lab(k),lat_lab(k)],line=1
   endif else begin
     xlglab = 0.5*(lat_lab(0)+lat_lab(1)) ; lat_lab(0)    ;
     xlgdel = long_lab(1)-long_lab(0)
     xltlab = long_lab(nlong_grid)   ;0.5*(long_lab(0)+long_lab(1))
     xltdel = lat_lab(1)-lat_lab(0)
;    map_grid,/label,latlab=-12,latdel=10,lonlab=72,londel=10,charsize=0.8
;    map_grid,/label,latlab=-35,latdel=5,lonlab=-35,londel=5,charsize=0.8
     map_grid,/label,latlab=xltlab,latdel=xltdel,lonlab=xlglab,londel=xlgdel,charsize=0.8,color=230
   endelse 
  endif
  
; ======= PLOT CONTINENTS -------------------------------------------------

  if icont eq 1 then begin
   if igpro eq 0 then begin
      contour_cont,filecont,resc_lg,resc_lt,ncont,igg_read,log1,log2,lat1,lat2,icont
   endif else begin
      map_continents,/countries,/coasts
;     if (kplot eq -21) then map_continents,/rivers,color=210 
   endelse
  endif

; ======= PLOT ELEVATION CONTOURS ----------------------------------------

   
  if i_elevcont eq 1 then begin
    close,90    
    openr,90,filecont
    
    nlgc=fix((log2-log1)/resc_lg+0.00001)
    nltc=fix((lat2-lat1)/resc_lt+0.00001)
    x=fltarr(nlgc,nltc)
    y=fltarr(nlgc,nltc)
    z=fltarr(nlgc,nltc)
    for ilg = 0,nlgc-1 do begin
     xlgc=log1+resc_lg*(0.5+ilg)
     x(ilg,*)=xlgc
    endfor
    for ilt = 0,nltc-1 do begin
     xltc=lat1+resc_lt*(0.5+ilt)
     y(*,ilt)=xltc
    endfor
    z(*,*)=-900.   
          
    for ig=long(0),ncont-long(1) do begin
     if igg_read eq 1 then begin
       readf,90,igg,xlgc,xltc,iii,cii,sii,sii,elev
     endif else begin
       readf,90,xlgc,xltc,elev
     endelse
     ilg = fix((xlgc-log1)/resc_lg)
     ilt = fix((xltc-lat1)/resc_lt)
     z(ilg,ilt) = elev
    endfor
    
    close,90
;    xtic_ev  = [0,200,400,600,800,1000,1200,1400,1600,1800,2000,2200,2400,2600,2800,3000,3200,3400,3600,3800,4000,4200,4400,4600,4800,5000]
;    clab_ev  =  [0,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1]
;    clines_ev = [0,1,1,1,1,0,1,1,1,1,0,1,1,1,1,0,1,1,1,1,0,1,1,1,1,0]
    xtic_ev  = [600,1000,1400,1800,2200,2600,3000]
    clab_ev  =  [1,1,1,1,1,1,1]
    clines_ev = [1,1,1,1,1,1,1]    
;    contour,z,x,y,/overplot,/irregular,levels=xtic_ev,c_labels=clab_ev,c_linestyle=clines_ev,charsize=0.8
    contour,z,x,y,/overplot,levels=xtic_ev,c_labels=clab_ev,c_linestyle=clines_ev,charsize=0.8    
   endif
   

; ======= REPLOT MAP BORDER ==============================================
if igpro eq 0 then begin
  oplot,[log1,log2],[lat1,lat1]
  oplot,[log1,log2],[lat2,lat2]
  oplot,[log1,log1],[lat1,lat2] 
  oplot,[log2,log2],[lat1,lat2]
endif	        

; ======= PLOT COLOR SCALE ===========================================

 !p.multi=[1,1,1]
 plot,[0,0],[0,0],xstyle=5,ystyle=5,xrange=[0.,1.],$
      yrange=[0.,1.],/nodata,xmargin=[0,0],ymargin=[0,0]

 
 jinc_div = -1
 for j = 0,ndiv+1 do begin
  if jpl_div(j) eq 1 then begin
   jinc_div = jinc_div+1
   lg1 = 0.55        ;0.50    ;0.88
   lg2 = lg1+0.03
   lt1 = 0.045+jinc_div*0.033   ;0.045+jinc_div*0.033
   lt2 = lt1 + 0.025    ;lt1 + 0.025
   lt3 = lt1 + 0.003
   ic = icv(j) 
   polyfill,[lg1,lg2,lg2,lg1,lg1],[lt1,lt1,lt2,lt2,lt1],color=ic
      oplot,[lg1,lg2],[lt1,lt1]
      oplot,[lg1,lg2],[lt2,lt2]
      oplot,[lg1,lg1],[lt1,lt2]
      oplot,[lg2,lg2],[lt1,lt2]
   if iclass eq 1 then begin
    labtic=tic_lab(j)  
   endif else begin
    if ic eq zerocol then begin
      form = '(1x,a10)'
      labtic=string(format=form,zeroleg)      
    endif else begin
     if j eq 0 then begin
      form = '(1x,a3,'+formtic+')'
      labtic=string(format=form,lowtic,xtic(j))
      if inoveg eq 1 then labtic = 'No vegetation'
      if inoveg eq 2 then labtic = 'Absence'
     endif else if j eq ndiv+1 then begin
      form = '(1x,a3,'+formtic+')'   
      labtic=string(format=form,hightic,xtic(j-1))
     endif else begin
      form = '(1x,'+formtic+',a3,'+formtic+')'  
      labtic=string(format=form,xtic(j-1),midtic,xtic(j))
      if inoveg ge 1 then begin
       if j eq 1 then begin
          form = '(1x,a3,'+formtic+')'
          labtic=string(format=form,lowtic,xtic(j))
       endif
      endif    
     endelse
    endelse
      
   endelse
   xyouts,lg2+0.01,lt3,labtic,charsize=0.88   
  endif
 endfor

; ======= PLOT TITLE ===========================================


 
 if ianom eq 0 then begin
    titre = graphname+varname
 endif else begin
    if ianom eq 1 then titre = 'Anomalies of '+graphname+varname
    if ianom eq 2 then titre = 'Increase factor of '+graphname+varname
 endelse
 xyouts,0.05,0.92,titre,alignment=0.,charsize = 1.3

 

; ======= CLOSE PLOTTING DEVICE ===========================================

 device,/close

;===============================================================================
; end of loop on plant type 
;===============================================================================
endfor

;===============================================================================
; end of loop on irun
;===============================================================================
endfor

return
end
