pro extract_WC
; default value for ifilform
ifilform = 0
;=========== TO BE CHANGED BY USER ==================================

ifile=0

if ifile eq 0 then begin
 ; extraction of a rectangular area 
 ; provide minimum and maximum longitudes/latitudes

;Luxemburg 
 lgmin = 5.7
 lgmax = 6.6  
 ltmin = 49.4 
 ltmax = 50.2   
 
endif else begin
 ; extraction of a set of pixels defined in an input file 
 ; provide the name of the input file and the number of pixels 
 ;      (i.e., lines) in the file 
 ; ifilform = flag to determine the format of input file 
 ; ifilform = -1 nnn,xlg,xlt
 ; ifilform = 0 xlg,xlt  
 ; ifilform = 1 xlg,xlt+species and species file rewritten as an output file
 ; nspecies = number of species considered when ifilform = 1 
   ifilform = -1 
   npix_max=long(31243)
   file_in='/raid3/umccb/clim0017/stufrancois/caraib/clim/Belgium/ecotxt_2017.dat'
endelse

; output directory where output files will be created
outdir='../clim/Luxemburg/'

;====================================================================

xlgtile=fltarr(12)
xlttile=fltarr(5) 

for ilg = 0, 11  do xlgtile(ilg)=-180.+(ilg+1)*30.
for ilt = 0, 4  do xlttile(ilt)=90.-(ilt+1)*30. 
 
exist_tile=fltarr(12,5)
for ilg = 0, 11  do begin 
  for ilt = 0, 4 do exist_tile(ilg,ilt)=0 
endfor
  
close,/all

if ifile eq 0 then begin

  if lgmin le -180 then lgmin = lgmin+360
  if lgmin gt 180 then lgmin = lgmin-360
  if lgmax le -180 then lgmax = lgmax+360
  if lgmax gt 180 then lgmax = lgmax-360
  if lgmin ge lgmax then begin
    print,'Minimum longitude larger than maximum longitude: ',lgmin,lgmax
    goto,finish
  endif
  if ltmin ge ltmax then begin
    print,'Minimum latitude larger than maximum latitude:',ltmin,ltmax
    goto,finish
  endif 
   
 dlong=1./120.
 dlat=1./120.
 nlong = long((lgmax-lgmin)*120.+0.00001)
 nlat = long((ltmax-ltmin)*120.+0.00001)
; print,nlong,nlat
 ylong = fltarr(nlong)
 ylat = fltarr(nlat)
 for ilong=1,nlong do ylong(ilong-1)=lgmin+dlong*(0.5+float(ilong-1))
 for ilat=1,nlat do ylat(ilat-1)=ltmin+dlat*(0.5+float(ilat-1))

 npix_max = long(nlong*nlat)
 xlong_pix=fltarr(npix_max)
 xlat_pix=fltarr(npix_max) 
 npix = long(0)
 for ilat = 1, nlat do begin
  for ilong = 1, nlong do begin
 ;  print,nlong,nlat,npix_max,npix
   xlong_pix(npix)=ylong(ilong-1)
   xlat_pix(npix)=ylat(ilat-1)
   npix = npix + long(1)
  endfor
 endfor 

endif else begin


 openr,10,file_in
 
 xlong_pix=fltarr(npix_max)
 xlat_pix=fltarr(npix_max)
 if ifilform eq 1 then begin 
  ioc_pix=intarr(npix_max,nspecies)
  ioc=intarr(nspecies)
 endif 

 for npix = long(0), npix_max-long(1) do begin
  if ifilform eq 1 then begin
    readf,10,xlg,xlt,ioc
  endif else begin
   if ifilform eq -1 then begin 
     readf,10,nnn,xlg,xlt
   endif else begin
     readf,10,xlg,xlt
   endelse
  endelse
  if xlg le -180 then xlg = xlg+360
  if xlg gt 180 then xlg = xlg-360
  xlong_pix(npix)=xlg
  xlat_pix(npix)=xlt
  if ifilform eq 1 then begin
   for isp=0,nspecies-1 do begin
     ioc_pix(npix,isp)=ioc(isp)
   endfor
  endif  
 endfor
  
endelse

tile_pix=intarr(npix_max,2)
alt_pix=fltarr(npix_max)
tmean_pix=fltarr(npix_max,12)
delt_pix=fltarr(npix_max,12)
prec_pix=fltarr(npix_max,12)

for npix = long(0), npix_max-long(1) do begin
  for ilg = 0, 11  do begin 
    if xlong_pix(npix) lt xlgtile(ilg) then begin
      tile_pix(npix,0)=ilg 
      goto,lg_end 
    endif
  endfor
  lg_end: 
  for ilt = 0, 4  do begin
    if xlat_pix(npix) gt xlttile(ilt) then begin
      tile_pix(npix,1)=ilt 
      goto,lt_end 
    endif
  endfor
  lt_end: 
  exist_tile(ilg,ilt)=1  
endfor


file20=outdir+'tile_number.res'
openw,20,file20

for ilt=0,4 do begin
 for ilg=0,11 do begin
  if exist_tile(ilg,ilt) eq 1 then begin 
   slt=string(ilt,format='(i1)',/print)
   if ilg le 9 then begin 
    slg=string(ilg,format='(i1)',/print) 
    printf,20,slt,slg,format='(a1,a1)'
   endif else begin
    slg=string(ilg,format='(i2)',/print)
    printf,20,slt,slg,format='(a1,a2)'
   endelse     
  endif  
 endfor
endfor

close,10
close,20

for ilt=0,4 do begin
 for ilg=0,11 do begin
  if exist_tile(ilg,ilt) eq 1 then begin 
   slt=string(ilt,format='(i1)',/print)
   if ilg le 9 then begin 
    slg=string(ilg,format='(i1)',/print) 
    tile=string(ilt,ilg,format='(i1,i1)',/print)
   endif else begin
    slg=string(ilg,format='(i2)',/print)
    tile=string(ilt,ilg,format='(i1,i2)',/print)
   endelse
   print,'Tile: ',tile
   latmax=90.-ilt*30.
   longmin=ilg*30.-180.
   var='alt'
   read_WC,tile,var,latmax,longmin,xlong,xlat,var_alt
   var='tmean'
   read_WC,tile,var,latmax,longmin,xlong,xlat,var_tmean
   var='tmax'
   read_WC,tile,var,latmax,longmin,xlong,xlat,var_tmax
   var='tmin'
   read_WC,tile,var,latmax,longmin,xlong,xlat,var_tmin 
   var='prec'
   read_WC,tile,var,latmax,longmin,xlong,xlat,var_prec        
;   outform='f5.1'
;   write_tile,tile,var,latmax,longmin,outdir,outform,xlong,xlat,var_tmean

   for npix = long(0), npix_max-long(1) do begin
     if tile_pix(npix,0) eq ilg then begin 
      if tile_pix(npix,1) eq ilt then begin       
;        print,xlong_pix(npix),xlat_pix(npix)
	ilg_pix=fix((xlong_pix(npix)-longmin)*120.)
	ilt_pix=fix((latmax-xlat_pix(npix))*120.)
	if var_alt(ilg_pix,ilt_pix,0) gt -900. then begin
	 alt_pix(npix)=var_alt(ilg_pix,ilt_pix,0)
	 tmean_pix(npix,*)=var_tmean(ilg_pix,ilt_pix,*)
	 delt_pix(npix,*)=var_tmax(ilg_pix,ilt_pix,*)-var_tmin(ilg_pix,ilt_pix,*)
	 for m=0,11 do begin
	  if delt_pix(npix,m) lt 0. then begin
	   print,'Tmax smaller than Tmin: ',tile,npix,m
	   print,'    ',var_tmax(ilg_pix,ilt_pix,m),var_tmin(ilg_pix,ilt_pix,m) 
	   delt_pix(npix)=0.
	  endif
	 endfor
	 prec_pix(npix,*)=var_prec(ilg_pix,ilt_pix,*)
;         print,ilg_pix,ilt_pix
        endif else begin
         alt_pix(npix)=-999.
	 tmean_pix(npix,*)=-99.9
	 delt_pix(npix,*)=-99.9
	 prec_pix(npix,*)=-999.
        endelse
      endif    
     endif
   endfor     
  endif  
 endfor
endfor

close,31
file31=outdir+'elev_WC1.dat'
openw,31,file31

close,32
file32=outdir+'tem_WC1.dat'
openw,32,file32

close,33
file33=outdir+'dte_WC1.dat'
openw,33,file33

close,34
file34=outdir+'prc_WC1.dat'
openw,34,file34

 if (ifile eq 1 ) and (ifilform eq 1) then begin
  close,38
  file38=outdir+'species_WC1.dat'
  openw,38,file38
 endif

for npix = long(0), npix_max-long(1) do begin
 if (alt_pix(npix) gt -900.) then begin
  printf,31,xlong_pix(npix),xlat_pix(npix),alt_pix(npix),format='(1x,f9.4,1x,f8.4,1x,f5.0)'
  printf,32,xlong_pix(npix),xlat_pix(npix),tmean_pix(npix,*),format='(1x,f9.4,1x,f8.4,12(1x,f5.1))'
  printf,33,xlong_pix(npix),xlat_pix(npix),delt_pix(npix,*),format='(1x,f9.4,1x,f8.4,12(1x,f5.1))'
  printf,34,xlong_pix(npix),xlat_pix(npix),prec_pix(npix,*),format='(1x,f9.4,1x,f8.4,12(1x,f5.0))'
  if (ifile eq 1 ) and (ifilform eq 1) then printf,38,xlong_pix(npix),xlat_pix(npix),ioc_pix(npix,*),format='(1x,f9.4,1x,f8.4,200(1x,i2))'
 endif
endfor


close,/all

;for npix = long(0), npix_max-long(1) do begin
;  slt=string(tile_pix(npix,1),format='(i1)',/print)
;  if tile_pix(npix,0) le 9 then begin 
;    slg=string(tile_pix(npix,0),format='(i1)',/print) 
;    printf,20,slt,slg,format='(a1,a1)'
;  endif else begin
;    slg=string(tile_pix(npix,0),format='(i2)',/print)
;    printf,20,slt,slg,format='(a1,a2)'
;  endelse 
;endfor

finish:

print,'End of program'

return
end 

;====================================================================================

pro read_WC,tile,var,latmax,longmin,xlong,xlat,var_mth

dlat=1./120.
dlong=1./120.

maindir='/raid/umccb/francois/WorldClim/GG_data/'


close,1
vari=intarr(3600,3600)
xlat=fltarr(3600)
xlong=fltarr(3600)

for ilat=1,3600 do xlat(ilat-1)=latmax-dlat*(0.5+float(ilat-1))
for ilong=1,3600 do xlong(ilong-1)=longmin+dlong*(0.5+float(ilong-1))

print,'Reading file(s)'
if var eq 'alt' then begin
   nm = 1
   var_mth=fltarr(3600,3600,nm)
   file=maindir+var+'_'+tile+'/'+var+'_'+tile+'.bil'
   print,file
   openr,1,file
   readu,1,vari
   var_mth(*,*,0)=float(vari(*,*))
   close,1
endif else begin
   nm = 12
   var_mth=fltarr(3600,3600,nm)
   if var eq 'prec' then scfac=1.
   if var eq 'tmean' then scfac=0.1
   if var eq 'tmin' then scfac=0.1
   if var eq 'tmax' then scfac=0.1   
   for m = 1, nm do begin
     if m le 9 then mth=string(m,format='(i1)',/print) else mth=string(m,format='(i2)',/print)
     print,mth
     file=maindir+var+'_'+tile+'/'+var+mth+'_'+tile+'.bil'
     print,file
     openr,1,file
     readu,1,vari
     close,1
     var_mth(*,*,m-1)=scfac*float(vari(*,*))
   endfor
endelse


return
end
     
;===================================================================================
pro write_tile,tile,var,latmax,longmin,outdir,outform,xlong,xlat,var_mth

outfile=outdir+var+'_'+tile+'.txt'
openw,2,outfile
print,'Writing file: ',outfile

form='(2(1x,f10.5),12(1x,'+outform+'))'

dlat=1./120.
dlong=1./120.
xlat=fltarr(3600)
xlong=fltarr(3600)

for ilat=1,3600 do xlat(ilat-1)=latmax-dlat*(0.5+float(ilat-1))
for ilong=1,3600 do xlong(ilong-1)=longmin+dlong*(0.5+float(ilong-1))

for ilat=1,3600 do begin
 for ilong=1,3600 do begin
  if var_mth(ilong-1,ilat-1,0) gt -900. then begin
    printf,2,xlong(ilong-1),xlat(ilat-1),var_mth(ilong-1,ilat-1,*),format=form
  endif
 endfor
endfor

close,2

return
end
